----------------------------------------------------------------------------

                  __    __
    ___  _ _     / /__ / /
   | _ \/ ` \ _ / // // _ \
   | ,_/_,_,_\  \_/\_/\___/
   |_|
                         An open source fortran library for hybrid 
                         particle-mesh based vortex method simulations.

                         By: Mads M. Hejlesen* and Jens H. Walther*^
                             * Technical University of Denmark
                             ^ ETH-Zurich 

----------------------------------------------------------------------------


----------------------------------------------------------------------------
- Citation
----------------------------------------------------------------------------
 For use in further scientific use please cite the following

 M. M. Hejlesen, P. Koumoutsakos, A. Leonard, and J. H. Walther, 
 "Iterative Brinkman penalization for remeshed vortex methods", 
 J. Comput. Phys., 280, 547-562, 2015.

 M. M. Hejlesen, J. T. Rasmussen, P. Chatelain and J. H. Walther, 
 "A high order solver for the unbounded Poisson equation", 
 J. Comput. Phys., 252, 458-467, 2013.

----------------------------------------------------------------------------
- LICENCE
----------------------------------------------------------------------------
 Copyright (c) 2014 Technical University of Denmark, 
                    Department of Mechanical Engineering

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, see <http://www.gnu.org/licenses/>

----------------------------------------------------------------------------
- CONTACTS
----------------------------------------------------------------------------
 Ph.D. stud. Mads M. Hejlesen:                     mmhej@mek.dtu.dk
 Prof. Jens H. Walther:                             jhwa@mek.dtu.dk

----------------------------------------------------------------------------
- INSTALL
----------------------------------------------------------------------------
1) compile the pmlib library
  * go to the pmlib directory
  * configure "Makefile" to the desired fortran compiler
  * compile pmlib by the "make" command

2) compile the pmlib client
  * go to the client directory
  * configure "Makefile" to the desired fortran compiler
  * compile pmlib by the "make" command

3) run the client using the input file "setup_cylinder.in" by:
$ ./client setup_cylinder.in

!---------------------------------------------------------------------------
! pmlib_interpolation.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_interpolation

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

!----------------------------------------------------------------------------
! Interfaces
!----------------------------------------------------------------------------
  INTERFACE pmlib_interp_m2p
    MODULE PROCEDURE pmlib_interp_m2p_var
    MODULE PROCEDURE pmlib_interp_m2p_class
  END INTERFACE

CONTAINS

#include "interpolation/pmlib_interp_p2m.f"
#include "interpolation/pmlib_interp_m2p_var.f"
#include "interpolation/pmlib_interp_m2p_class.f"

END MODULE pmlib_mod_interpolation

!----------------------------------------------------------------------!
! pmlib_poisson_solve_fftw.f
!   version: 2D single-core
!----------------------------------------------------------------------!
! <<HEADER>>
!----------------------------------------------------------------------!
SUBROUTINE pmlib_poisson_solve(patch,topo_all,mesh,ierr,reg_vort)

USE pmlib_mod_patch
USE pmlib_mod_topology
USE pmlib_mod_mesh
USE pmlib_mod_fourier
USE pmlib_mod_communication

IMPLICIT NONE

INCLUDE 'fftw3.f'
!----------------------------------------------------------------------!
! Arguments
!----------------------------------------------------------------------!
  TYPE(class_patch)                             :: patch
  TYPE(class_topology_all)                      :: topo_all
  TYPE(class_mesh)                              :: mesh
  INTEGER, INTENT(OUT)                          :: ierr
  LOGICAL, OPTIONAL, INTENT(IN)                 :: reg_vort

!----------------------------------------------------------------------!
! Local variables
!----------------------------------------------------------------------!
  CHARACTER(LEN=20)                 :: caller = 'pmlib_poisson_solve'
  REAL(MK)                          :: PI

  INTEGER                           :: i,j,l

  REAL(MK)                          :: px, py
  REAL(MK)                          :: rho

  INTEGER, DIMENSION(pmlib_ndim)    :: ncell
  INTEGER, DIMENSION(2*pmlib_ndim)  :: nghost
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin
  REAL(MK), DIMENSION(pmlib_ndim)   :: dx 

  INTEGER                           :: i_ptc, j_ptc
  REAL(MK), DIMENSION(pmlib_ndim)   :: l_ptc, ks, dk, kmin
  REAL(MK)                          :: ki, kj, s
  REAL(MK)                          :: eps
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin_ptc, xmax_ptc
  INTEGER, DIMENSION(pmlib_ndim)    :: bc_ptc

  REAL(MK)                          :: c1, c2, c3, c4, c5

  INTEGER, DIMENSION(pmlib_ndim)    :: fft_seq, ifft_seq
  LOGICAL                           :: ifft_vort

  COMPLEX(MKC)                      :: G, Kx, Ky
  COMPLEX(MKC)                      :: zeta_fft

  INTEGER                           :: nfft

  COMPLEX(MKC),DIMENSION(:,:,:),POINTER :: vel_fft, vort_fft 

  COMPLEX(MKC),DIMENSION(:),POINTER :: fft1_in   => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: fft1_out  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft1_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft1_out => NULL()

  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft2_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft2_out => NULL()

  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft3_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft3_out => NULL()

  INTEGER                           :: fft_plan, ifft_plan

  TYPE(class_topology)              :: topo_second

!----------------------------------------------------------------------!
! Initiate
!----------------------------------------------------------------------!
  ierr = 0
  PI = ACOS(-1.0_MK)

  ifft_vort = .FALSE.
  IF(PRESENT(reg_vort) .AND. reg_vort)THEN
    ifft_vort = .TRUE.
  END IF  

!----------------------------------------------------------------------!
! Determine the fft sequence
!----------------------------------------------------------------------!
  fft_seq = patch%fft_seq

  IF(fft_seq(2) .EQ. 1)THEN
    topo_second = topo_all%xpencil
  ELSEIF(fft_seq(2) .EQ. 2)THEN
    topo_second = topo_all%ypencil
  ELSE
      ierr = -1
      CALL pmlib_write(caller, 'fft direction unknown.')
      GOTO 9999
  END IF

!----------------------------------------------------------------------!
! Allocate Fourier coefficients for velocity field
!----------------------------------------------------------------------!
  ncell   = topo_second%ncell
  ALLOCATE( vel_fft(pmlib_ndim,ncell(1),ncell(2)) )

!----------------------------------------------------------------------!
! FFT the field in the first two directions and map to the third direction
!----------------------------------------------------------------------!
  fft_seq(2) = 0
  CALL pmlib_fft( topo_all,topo_all%cuboid,mesh%vort,topo_second,vort_fft, &
                & fft_seq,ierr,fft_shift = .FALSE.)

!----------------------------------------------------------------------!
! Setup the third direction
!----------------------------------------------------------------------!
  fft_seq  = patch%fft_seq
  ncell    = topo_second%ncell
  dx       = topo_second%dx
  xmin     = topo_second%xmin

  DO i = 1,pmlib_ndim
    IF( patch%bound_cond(i) .NE. 0 )THEN
      bc_ptc(i) = 1
    ELSE
      bc_ptc(i) = 0
    END IF
  END DO

! Include/exclude ghost cells
  xmin_ptc = patch%xmin - &
           & REAL(( 1 - bc_ptc ) * patch%nghost,MK)*patch%dx
  xmax_ptc = patch%xmax + &
           & REAL(( 1 - bc_ptc ) * patch%nghost,MK)*patch%dx

!----------------------------------------------------------------------!
! Setup wavenumber parameters
!----------------------------------------------------------------------!
  l_ptc(1) = REAL(2 - bc_ptc(1),MK)*(xmax_ptc(1) - xmin_ptc(1))
  l_ptc(2) = REAL(2 - bc_ptc(2),MK)*(xmax_ptc(2) - xmin_ptc(2))

  dk(1) = 2.0_MK*PI/l_ptc(1)
  dk(2) = 2.0_MK*PI/l_ptc(2)

! patch index
  i_ptc = NINT((xmin(1) - xmin_ptc(1))/dx(1))
  j_ptc = NINT((xmin(2) - xmin_ptc(2))/dx(2))

  kmin(1) = - PI/dx(1) + REAL(i_ptc,MK) * dk(1)
  kmin(2) = - PI/dx(2) + REAL(j_ptc,MK) * dk(2)

  eps = pmlib_regularisation_radius*MAXVAL(dx)

!----------------------------------------------------------------------!
! Setup coefficients for the regularisation filter
!----------------------------------------------------------------------!
  c1 = 1.0_MK
  c2 = 0.5_MK
  c3 = 0.125_MK
  c4 = 1.0_MK/48.0_MK
  c5 = 1.0_MK/384.0_MK

!----------------------------------------------------------------------!
! FFT the field in the third direction, convolve and IFFT
!----------------------------------------------------------------------!
  IF(fft_seq(2) .EQ. 1)THEN ! Convolve on x-pencils

    IF(bc_ptc(1) .EQ. 0)THEN
      nfft = 2*ncell(1)
    ELSE
      nfft = ncell(1)
    END IF

! Allocate fft pencils
    ALLOCATE( fft1_in(nfft), fft1_out(nfft), ifft1_in(nfft), ifft1_out(nfft) )
    ALLOCATE( ifft2_in(nfft), ifft2_out(nfft) )
    IF( ifft_vort )THEN
      ALLOCATE( ifft3_in(nfft), ifft3_out(nfft) )
    END IF

    DO j = 1, ncell(2)
! Calculate wave number (FFT-shifted)
      IF( j + j_ptc .LE.  NINT(l_ptc(2)/(2.0_MK*dx(2))) )THEN
        kj = kmin(2) + REAL(j - 1,MK)*dk(2) + PI/dx(2)
      ELSE
        kj = kmin(2) + REAL(j - 1,MK)*dk(2) - PI/dx(2)
      END IF

! Store fft pencil
      DO i = 1, nfft
        IF( i .LE. ncell(1) )THEN
          fft1_in(i) = vort_fft(1,i,j)
        ELSE ! zero padding
          fft1_in(i) = CMPLX(0.0_MK,0.0_MK,MKC)
        END IF
      END DO

! Fourier transform
      CALL dfftw_plan_dft_1d( fft_plan, nfft, fft1_in, fft1_out, & 
                          & FFTW_FORWARD, FFTW_ESTIMATE)
      CALL dfftw_execute_dft( fft_plan, fft1_in, fft1_out )
      CALL dfftw_destroy_plan( fft_plan )

      DO i = 1,nfft
! Calculate wave number in x-direction (FFT-shifted)
        IF( i + i_ptc .LE.  NINT(l_ptc(1)/(2.0_MK*dx(1))) )THEN
          ki = kmin(1) + REAL(i - 1,MK)*dk(1) + PI/dx(1)
        ELSE
          ki = kmin(1) + REAL(i - 1,MK)*dk(1) - PI/dx(1)
        END IF 

! Regularise output the vorticity field
        IF( ifft_vort )THEN
          s = eps*SQRT( ki**2 + kj**2 )

          IF(pmlib_poisson_order .EQ. 0)THEN             
            zeta_fft = CMPLX(1.0_MK,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 2)THEN
            zeta_fft = CMPLX( c1  &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 4)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 6)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 8)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 + c4*s**6 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 10)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 + c4*s**6 &
                     & + c5*s**8 ) * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          END IF

! Regularise
          ifft3_in(i) = fft1_out(i) * zeta_fft
        END IF

        IF(pmlib_poisson_kernel .EQ. 1)THEN
! Get the Poisson integration kernel
          G = mesh%pkernel_fft(1,i,j) *dx(1)*dx(2)

! convolve and do spectral curl to get the FFT coefficients of the velocity
          ifft1_in(i) =   G * CMPLX(0.0_MK,kj,MKC) * fft1_out(i)
          ifft2_in(i) = - G * CMPLX(0.0_MK,ki,MKC) * fft1_out(i)

        ELSEIF(pmlib_poisson_kernel .EQ. 2)THEN
! Get the derivative Poisson integration kernel
          Kx = mesh%pkernel_fft(1,i,j) *dx(1)*dx(2)
          Ky = mesh%pkernel_fft(2,i,j) *dx(1)*dx(2)

! Convolve and do spectral curl to get the FFT coefficients of the velocity
          ifft1_in(i) =   Ky * fft1_out(i)
          ifft2_in(i) = - Kx * fft1_out(i)

        END IF

      END DO

! Inverse Fourier transform
      CALL dfftw_plan_dft_1d( ifft_plan, nfft, ifft1_in, ifft1_out, &
                            & FFTW_BACKWARD, FFTW_ESTIMATE)
      CALL dfftw_execute_dft( ifft_plan, ifft1_in, ifft1_out )
      CALL dfftw_execute_dft( ifft_plan, ifft2_in, ifft2_out )
      IF( ifft_vort )THEN
        CALL dfftw_execute_dft( ifft_plan, ifft3_in, ifft3_out )
      END IF
      CALL dfftw_destroy_plan( ifft_plan )

! Store fourier coefficients discard zero-padding
      DO i = 1,ncell(1)
        vel_fft(1,i,j) = ifft1_out(i)/REAL(nfft,MK)
        vel_fft(2,i,j) = ifft2_out(i)/REAL(nfft,MK)
        IF( ifft_vort )THEN
          vort_fft(1,i,j) = ifft3_out(i)/REAL(nfft,MK)
        END IF
      END DO

    END DO !j

! Clean fftw
    CALL dfftw_cleanup()

  ELSEIF(fft_seq(2) .EQ. 2)THEN ! Convolve on y-pencils

    IF(bc_ptc(2) .EQ. 0)THEN
      nfft = 2*ncell(2)
    ELSE
      nfft = ncell(2)
    END IF

! Allocate fft pencils
    ALLOCATE( fft1_in(nfft), fft1_out(nfft), ifft1_in(nfft), ifft1_out(nfft) )
    ALLOCATE( ifft2_in(nfft), ifft2_out(nfft) )
    IF( ifft_vort )THEN
      ALLOCATE( ifft3_in(nfft), ifft3_out(nfft) )
    END IF

    DO i = 1,ncell(1)
! Calculate wave number in x-direction (FFT-shifted)
      IF( i + i_ptc .LE.  NINT(l_ptc(1)/(2.0_MK*dx(1))) )THEN
        ki = kmin(1) + REAL(i - 1,MK)*dk(1) + PI/dx(1)
      ELSE
        ki = kmin(1) + REAL(i - 1,MK)*dk(1) - PI/dx(1)
      END IF 

! Store fft pencil
      DO j = 1, nfft
        IF( j .LE. ncell(2) )THEN
          fft1_in(j) = vort_fft(1,i,j)
        ELSE ! zero padding
          fft1_in(j) = CMPLX(0.0_MK,0.0_MK,MKC)
        END IF
      END DO

! Fourier transform
      CALL dfftw_plan_dft_1d( fft_plan, nfft, fft1_in, fft1_out, & 
                          & FFTW_FORWARD, FFTW_ESTIMATE)
      CALL dfftw_execute_dft( fft_plan, fft1_in, fft1_out )
      CALL dfftw_destroy_plan( fft_plan )

      DO j = 1, nfft
! Calculate wave number in y-direction (FFT-shifted)
        IF( j + j_ptc .LE.  NINT(l_ptc(2)/(2.0_MK*dx(2))) )THEN
          kj = kmin(2) + REAL(j - 1,MK)*dk(2) + PI/dx(2)
        ELSE
          kj = kmin(2) + REAL(j - 1,MK)*dk(2) - PI/dx(2)
        END IF

! Regularise the output vorticity field
        IF( ifft_vort )THEN
          s = eps*SQRT( ki**2 + kj**2 )

          IF(pmlib_poisson_order .EQ. 0)THEN             
            zeta_fft = CMPLX(1.0_MK,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 2)THEN
            zeta_fft = CMPLX( c1  &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 4)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 6)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 8)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 + c4*s**6 ) &
                     & * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          ELSEIF(pmlib_poisson_order .EQ. 10)THEN
            zeta_fft = CMPLX(( c1 + c2*s**2 + c3*s**4 + c4*s**6 &
                     & + c5*s**8 ) * EXP(-0.5_MK*s**2) ,0.0_MK,MKC)
          END IF

! Regularise
          ifft3_in(j) = fft1_out(j) * zeta_fft
        END IF

        IF(pmlib_poisson_kernel .EQ. 1)THEN
! Get the Poisson integration kernel
          G = mesh%pkernel_fft(1,i,j) *dx(1)*dx(2)

! Convolve and do spectral curl to get the FFT coefficients of the velocity
          ifft1_in(j) =   G * CMPLX(0.0_MK,kj,MKC) * fft1_out(j)
          ifft2_in(j) = - G * CMPLX(0.0_MK,ki,MKC) * fft1_out(j) 

        ELSEIF(pmlib_poisson_kernel .EQ. 2)THEN
! Get the derivative Poisson integration kernel
          Kx = mesh%pkernel_fft(1,i,j) *dx(1)*dx(2)
          Ky = mesh%pkernel_fft(2,i,j) *dx(1)*dx(2)

! Convolve and do spectral curl to get the FFT coefficients of the velocity
          ifft1_in(j) =   Ky * fft1_out(j)
          ifft2_in(j) = - Kx * fft1_out(j)

        END IF
      END DO

! Inverse Fourier transform
      CALL dfftw_plan_dft_1d( ifft_plan, nfft, ifft1_in, ifft1_out, &
                            & FFTW_BACKWARD, FFTW_ESTIMATE)
      CALL dfftw_execute_dft( ifft_plan, ifft1_in, ifft1_out )
      CALL dfftw_execute_dft( ifft_plan, ifft2_in, ifft2_out )
      IF( ifft_vort )THEN
        CALL dfftw_execute_dft( ifft_plan, ifft3_in, ifft3_out )
      END IF
      CALL dfftw_destroy_plan( ifft_plan )

! Store fourier coefficients discard zero-padding
      DO j = 1,ncell(2)
        vel_fft(1,i,j) = ifft1_out(j)/REAL(nfft,MK)
        vel_fft(2,i,j) = ifft2_out(j)/REAL(nfft,MK)
        IF( ifft_vort )THEN
          vort_fft(1,i,j) = ifft3_out(j)/REAL(nfft,MK)
        END IF
      END DO

    END DO !i

! Clean fftw
    CALL dfftw_cleanup()

  END IF

!----------------------------------------------------------------------!
! De-allocate fft arrays
!----------------------------------------------------------------------!
  DEALLOCATE( fft1_in, fft1_out )
  DEALLOCATE( ifft1_in, ifft1_out )
  DEALLOCATE( ifft2_in, ifft2_out )

  IF( ifft_vort )THEN
    DEALLOCATE( ifft3_in, ifft3_out )
  END IF

!----------------------------------------------------------------------!
! IFFT velocity field in the first direction
!----------------------------------------------------------------------!
  ifft_seq(1) = patch%fft_seq(1)
  ifft_seq(2) = 0
  CALL pmlib_ifft( topo_all,topo_second,vel_fft,topo_all%cuboid,mesh%vel, &
                 & ifft_seq,ierr,fft_shift = .FALSE.)

  IF( ifft_vort )THEN
    CALL pmlib_ifft( topo_all,topo_second,vort_fft,topo_all%cuboid,mesh%vort, &
                   & ifft_seq,ierr,fft_shift = .FALSE.)
  END IF

!----------------------------------------------------------------------!
! Deallocate local pointers
!----------------------------------------------------------------------!
  IF( ASSOCIATED(vort_fft) )THEN 
    DEALLOCATE(vort_fft)
  END IF
  IF( ASSOCIATED(vel_fft) ) THEN
    DEALLOCATE(vel_fft)
  END IF

!----------------------------------------------------------------------!
! Return
!----------------------------------------------------------------------!
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_poisson_solve

!---------------------------------------------------------------------------
! pmlib_particles_advance.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_particles_advance(patch,topo,part,itimestage,dtime,ierr,euler_vort)

USE pmlib_mod_patch
USE pmlib_mod_topology
USE pmlib_mod_communication

IMPLICIT NONE

!-------------------------------------------------------------------------
! Arguments
!-------------------------------------------------------------------------
  TYPE(class_patch)                         :: patch
  TYPE(class_topology)                      :: topo
  TYPE(class_particles)                     :: part
  INTEGER, INTENT(IN)                       :: itimestage
  REAL(MK), INTENT(IN)                      :: dtime
  INTEGER, INTENT(OUT)                      :: ierr
  LOGICAL, INTENT(IN), OPTIONAL             :: euler_vort

!---------------------------------------------------------------------------
!  Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=23)                   :: caller = 'pmlib_particles_advance'
  INTEGER                                   :: i,j,k

  REAL(MK),DIMENSION(pmlib_ndim)            :: xmin, xmax
  INTEGER,DIMENSION(pmlib_ndim)             :: bc

  REAL(MK),DIMENSION(3)                     :: a1, a2, b1, b2, c1, c2

  REAL(MK)                                  :: vort_max_loc

  LOGICAL                                   :: map_done, map_done_gl
  INTEGER                                   :: npart_glo1, npart_glo2 

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! Set time integration scheme coefficients
!---------------------------------------------------------------------------
  IF(pmlib_time_integration_order .EQ. 1)THEN
! Position
    a1 = (/ 0.0_MK, 0.0_MK, 0.0_MK /)
    b1 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
    c1 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
! Vorticity
    a2 = (/ 0.0_MK, 0.0_MK, 0.0_MK /)
    b2 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
    c2 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
  ELSEIF(pmlib_time_integration_order .EQ. 2)THEN
! Position
    a1 = (/ 0.0_MK, -0.5_MK, 0.0_MK /)
    b1 = (/ 1.0_MK,  1.0_MK, 0.0_MK /)
    c1 = (/ 0.5_MK,  1.0_MK, 0.0_MK /)
! Vorticity
    IF( PRESENT(euler_vort) .AND. euler_vort )THEN
      a2 = (/ 0.0_MK, 1.0_MK, 0.0_MK /)
      b2 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
      c2 = (/ 0.5_MK, 0.5_MK, 0.0_MK /)
    ELSE 
      a2 = (/ 0.0_MK, -0.5_MK, 0.0_MK /)
      b2 = (/ 1.0_MK,  1.0_MK, 0.0_MK /)
      c2 = (/ 0.5_MK,  1.0_MK, 0.0_MK /)
    END IF
  ELSEIF(pmlib_time_integration_order .EQ. 3)THEN
! Position
    a1 = (/ 0.0_MK, -5.0_MK/9.0_MK, -153.0_MK/128.0_MK /)
    b1 = (/ 1.0_MK, 1.0_MK, 1.0_MK /)
    c1 = (/ 1.0_MK/3.0_MK, 15.0_MK/16.0_MK, 8.0_MK/15.0_MK /)
! Vorticity
    IF( PRESENT(euler_vort) .AND. euler_vort )THEN
      a2 = (/ 0.0_MK, 1.0_MK, 1.0_MK /)
      b2 = (/ 1.0_MK, 0.0_MK, 0.0_MK /)
      c2 = (/ 1.0_MK/3.0_MK, 1.0_MK/3.0_MK, 1.0_MK/3.0_MK /)
    ELSE 
      a2 = (/ 0.0_MK, -5.0_MK/9.0_MK, -153.0_MK/128.0_MK /)
      b2 = (/ 1.0_MK, 1.0_MK, 1.0_MK /)
      c2 = (/ 1.0_MK/3.0_MK, 15.0_MK/16.0_MK, 8.0_MK/15.0_MK /)
    END IF
  END IF

!---------------------------------------------------------------------------
! Advance particle possition and vorticity
!---------------------------------------------------------------------------
  vort_max_loc = 0.0_MK

  DO i = 1,topo%npart
! the storage 
    part%vel_rk(1:pmlib_ndim,i) = &
                  &   a1(itimestage)*part%vel_rk(1:pmlib_ndim,i) &
                  & + b1(itimestage)*dtime*part%vel(1:pmlib_ndim,i)

    part%dvort_rk(1:pmlib_nvort,i) = &
                  &   a2(itimestage)*part%dvort_rk(1:pmlib_nvort,i) &
                  & + b2(itimestage)*dtime*part%dvort(1:pmlib_nvort,i)


! the time integration
    part%pos(1:pmlib_ndim,i) = part%pos(1:pmlib_ndim,i) &
                  & + c1(itimestage)*part%vel_rk(1:pmlib_ndim,i)

    part%vort(1:pmlib_nvort,i) = part%vort(1:pmlib_nvort,i) &
                  & + c2(itimestage)*part%dvort_rk(1:pmlib_nvort,i)

  END DO !ipart
!---------------------------------------------------------------------------
! Communicate particles
!---------------------------------------------------------------------------
  IF(pmlib_time_integration_order .EQ. 1)THEN
    DO i = 1,pmlib_ndim
!      map_done_gl = .FALSE.
!      DO WHILE(.NOT. map_done_gl)
! setup particle communication
        CALL pmlib_particles_map( patch,topo,part,i, & 
                                & pmlib_nvort+pmlib_ndim,ierr)
! pack
        CALL pmlib_comm_pack(part%pos,ierr)
        CALL pmlib_comm_pack(part%vort,ierr)
! unpack
        CALL pmlib_comm_unpack(topo,part%vort,ierr)
        CALL pmlib_comm_unpack(topo,part%pos,map_done,i,ierr)
! finalise
        CALL pmlib_comm_finalise(ierr)
!      END DO
    END DO

  ELSE
    DO i = 1,pmlib_ndim
!      map_done_gl = .FALSE.
!      DO WHILE(.NOT. map_done_gl)
! setup particle communication
        CALL pmlib_particles_map( patch,topo,part,i, &
                                & 2*(pmlib_nvort+pmlib_ndim),ierr)
! pack
        CALL pmlib_comm_pack(part%pos,ierr)
        CALL pmlib_comm_pack(part%vort,ierr)
        CALL pmlib_comm_pack(part%vel_rk,ierr)
        CALL pmlib_comm_pack(part%dvort_rk,ierr)
! unpack
        CALL pmlib_comm_unpack(topo,part%dvort_rk,ierr)
        CALL pmlib_comm_unpack(topo,part%vel_rk,ierr)
        CALL pmlib_comm_unpack(topo,part%vort,ierr)
        CALL pmlib_comm_unpack(topo,part%pos,map_done,i,ierr)
! finalise
        CALL pmlib_comm_finalise(ierr)
!      END DO
    END DO

  END IF

!---------------------------------------------------------------------------
! Check the total number of particles
!---------------------------------------------------------------------------
!  IF(SIZE(part%pos,2) .NE. topo(mpi_rank)%npart)THEN
!    CALL pmlib_write( mpi_rank,caller, &
!                     & 'Particle array does not correspond.')
!  END IF

!  CALL MPI_ALLREDUCE( topo(mpi_rank)%npart,npart_glo2,1,mpi_prec_int, &
!                    & MPI_SUM,comm,ierr)

!  IF( npart_glo1 .NE. npart_glo2 )THEN
!    ierr = -1
!    CALL pmlib_write( mpi_rank,caller, &
!                    & 'Number of particles are not conserved.',verb=.TRUE.)
!    GOTO 9999
!  END IF


!---------------------------------------------------------------------------
! Reallocate particle time derivatives
!---------------------------------------------------------------------------
  DEALLOCATE(part%vel)
  ALLOCATE(part%vel(pmlib_ndim,topo%npart))

  DEALLOCATE(part%dvort)
  ALLOCATE(part%dvort(pmlib_nvort,topo%npart))

  IF(pmlib_time_integration_order .EQ. 1)THEN
    DEALLOCATE(part%vel_rk)
    ALLOCATE(part%vel_rk(pmlib_ndim,topo%npart))
    part%vel_rk = 0.0_MK

    DEALLOCATE(part%dvort_rk)
    ALLOCATE(part%dvort_rk(pmlib_nvort,topo%npart))
    part%dvort_rk = 0.0_MK

  END IF

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN

END SUBROUTINE pmlib_particles_advance

!---------------------------------------------------------------------------
! pmlib_parameters.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_parameters

USE pmlib_mod_write

IMPLICIT NONE
!----------------------------------------------------------------------------
! Arithmetic precision
!----------------------------------------------------------------------------
#ifdef __single
! Single precision
  INTEGER, PARAMETER               :: MK               = KIND(1E0)
  INTEGER, PARAMETER               :: MKC              = KIND(CMPLX(1E0,1E0,MK))
#elif __double
! Double precision
  INTEGER, PARAMETER               :: MK               = KIND(1D0)
  INTEGER, PARAMETER               :: MKC              = KIND(CMPLX(1D0,1D0,MK))
#else

#error "Arithmetic presicion is not defined"

#endif

  INTEGER, PARAMETER               :: MAXCHAR          = 256

!---------------------------------------------------------------------------
! Number of dimensions
!---------------------------------------------------------------------------
  INTEGER, PARAMETER               :: pmlib_ndim  = 2
  INTEGER, PARAMETER               :: pmlib_nvort = 1

!---------------------------------------------------------------------------
! Numerical parameters
!---------------------------------------------------------------------------
  REAL(MK)                         :: pmlib_regularisation_radius = 0.0_MK
  INTEGER                          :: pmlib_poisson_kernel = -99
  INTEGER                          :: pmlib_poisson_order = -99
  INTEGER                          :: pmlib_fd_order = -99
  INTEGER                          :: pmlib_interpolation_order = -99
  INTEGER                          :: pmlib_time_integration_order = -99

CONTAINS

#include "parameters/pmlib_parameters_check.f"

END MODULE pmlib_mod_parameters

!---------------------------------------------------------------------------
! pmlib_remesh.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_remesh(patch,topo,mesh,part,min_vort,min_dvort,ierr,dvort,vel)

USE pmlib_mod_mesh
USE pmlib_mod_particles
USE pmlib_mod_patch
USE pmlib_mod_topology

IMPLICIT NONE

!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_patch)                         :: patch
  TYPE(class_topology)                      :: topo
  TYPE(class_mesh)                          :: mesh
  TYPE(class_particles)                     :: part
  REAL(MK), INTENT(IN)                      :: min_vort
  REAL(MK), INTENT(IN)                      :: min_dvort
  INTEGER, INTENT(OUT)                      :: ierr
  LOGICAL, OPTIONAL                         :: dvort
  LOGICAL, OPTIONAL                         :: vel

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  REAL(MK)                                :: px, py
  REAL(MK)                                :: strength, dstrength
  INTEGER                                 :: i, j, k, l
  INTEGER                                 :: inp
  REAL(MK),DIMENSION(pmlib_ndim)          :: xmin, dx
  INTEGER,DIMENSION(pmlib_ndim)           :: ncell

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

  dx     = topo%dx
  ncell  = topo%ncell
  xmin   = topo%xmin

!---------------------------------------------------------------------------
! Deallocate the particles if they are already allocated
!---------------------------------------------------------------------------
  IF(ASSOCIATED( part%pos )) DEALLOCATE(part%pos,stat=ierr)

  IF(ASSOCIATED( part%vel )) DEALLOCATE(part%vel,stat=ierr)

  IF(ASSOCIATED( part%vort )) DEALLOCATE(part%vort,stat=ierr)

  IF(ASSOCIATED( part%dvort )) DEALLOCATE(part%dvort,stat=ierr)

  IF(ASSOCIATED( part%vel_rk )) DEALLOCATE(part%vel_rk,stat=ierr)

  IF(ASSOCIATED( part%dvort_rk )) DEALLOCATE(part%dvort_rk,stat=ierr)

  IF(ierr .NE. 0) THEN
    CALL pmlib_write( 'pmlib_remesh_particles', &
                    & 'Failed to deallocate existing particles.')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! Find the number of particles
!---------------------------------------------------------------------------
  inp = 0
    DO j = 1, ncell(2)
      DO i = 1, ncell(1)

        strength  = ABS( mesh%vort(1,i,j) )
        dstrength = ABS( mesh%dvort(1,i,j) )

        IF( strength .GT. min_vort .OR. &
          & dstrength .GT. min_dvort) THEN

          inp = inp + 1
        END IF

      END DO
    END DO

  topo%npart = inp

!---------------------------------------------------------------------------
! Allocate particles
!---------------------------------------------------------------------------
  ALLOCATE( part%pos(pmlib_ndim,inp), part%vort(pmlib_nvort,inp), &
          & part%vel(pmlib_ndim,inp), part%dvort(pmlib_nvort,inp) )

  ALLOCATE( part%vel_rk(pmlib_ndim,inp), &
          & part%dvort_rk(pmlib_nvort,inp) )

!---------------------------------------------------------------------------
! Create particles
!---------------------------------------------------------------------------
  inp = 0

    DO j = 1, ncell(2)
      py = xmin(2) + (REAL(j - 1,MK) + 0.5_MK) *dx(2)

      DO i = 1, ncell(1)
        px = xmin(1) + (REAL(i - 1,MK) + 0.5_MK) *dx(1)

        strength  = ABS( mesh%vort(1,i,j) )
        dstrength = ABS( mesh%dvort(1,i,j) )

        IF( strength .GT. min_vort .OR. &
          & dstrength .GT. min_dvort) THEN

          inp = inp + 1

          part%pos(1,inp) = px
          part%pos(2,inp) = py

          IF( PRESENT(vel) .AND. vel )THEN
            part%vel(1:pmlib_ndim,inp) = mesh%vel(1:pmlib_ndim,i,j)
          ELSE
            part%vel(1:pmlib_ndim,inp) = 0.0_MK
          END IF

          part%vel_rk(1:pmlib_ndim,inp) = 0.0_MK

          part%vort(1:pmlib_nvort,inp) = mesh%vort(1:pmlib_nvort,i,j)

          IF( PRESENT(dvort) .AND. dvort )THEN
            part%dvort(1:pmlib_nvort,inp) = mesh%dvort(1:pmlib_nvort,i,j)
          ELSE
            part%dvort(1:pmlib_nvort,inp) = 0.0_MK
          END IF
          part%dvort_rk(1:pmlib_nvort,inp) = 0.0_MK

        END IF

      END DO
    END DO

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_remesh

!---------------------------------------------------------------------------
! pmlib_fourier_fft.f
!   version: 2D single-core
!---------------------------------------------------------------------------
! <<HEADER>>
!---------------------------------------------------------------------------
SUBROUTINE pmlib_fft( topo_all,topo_in,mesh,topo_out,mesh_fft,fft_seq, &
                    & ierr,fft_shift)

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology_all)                        :: topo_all
  TYPE(class_topology)                            :: topo_in
  TYPE(class_topology)                            :: topo_out
  REAL(MK),DIMENSION(:,:,:),POINTER               :: mesh
  INTEGER, DIMENSION(pmlib_ndim), INTENT(IN)      :: fft_seq
  LOGICAL, OPTIONAL, INTENT(IN)                   :: fft_shift
  COMPLEX(MKC),DIMENSION(:,:,:),POINTER           :: mesh_fft
  INTEGER, INTENT(OUT)                            :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=10)                 :: caller = 'pmlib_fft'
  INTEGER                           :: i,j,k,l,m

  INTEGER, DIMENSION(pmlib_ndim)    :: ncell
  INTEGER, DIMENSION(2*pmlib_ndim)  :: nghost
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin, xmax, dx 

  INTEGER                           :: nvar
  INTEGER                           :: nfft

  COMPLEX(MKC),DIMENSION(:),POINTER :: fft_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: fft_out => NULL()

  TYPE(class_topology)              :: topo_send
  TYPE(class_topology)              :: topo_recieve

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0
  nvar = SIZE(mesh,1)

!---------------------------------------------------------------------------
! Move the real mesh to the complex fft mesh
!---------------------------------------------------------------------------
  ncell  = topo_in%ncell
  nghost = topo_in%nghost

  IF( ASSOCIATED(mesh_fft) ) THEN
    DEALLOCATE(mesh_fft,stat=ierr)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF

  ALLOCATE(mesh_fft(nvar, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)
  IF (ierr .NE. 0) THEN
    CALL pmlib_write(caller,'Failed to allocate array.')
    GOTO 9999
  ENDIF

    DO j = 1 - nghost(3), ncell(2) + nghost(4)
      DO i = 1 - nghost(1), ncell(1) + nghost(2)
        DO l = 1,nvar
          mesh_fft(l,i,j) = CMPLX(mesh(l,i,j),0.0_MK,MKC)
        END DO
      END DO
    END DO

!---------------------------------------------------------------------------
! Fourier transform
!---------------------------------------------------------------------------
  DO m = 1,pmlib_ndim
    IF(fft_seq(m) .EQ. 0)THEN
      GOTO 100
    END IF
!---------------------------------------------------------------------------
! Map topology to the fft direction
!---------------------------------------------------------------------------
    IF(m .EQ. 1)THEN
      topo_send = topo_in
    END IF

    IF(fft_seq(m) .EQ. 1)THEN
      topo_recieve = topo_all%xpencil
    ELSEIF(fft_seq(m) .EQ. 2)THEN
      topo_recieve = topo_all%ypencil
    ELSE
        ierr = -1
        CALL pmlib_write(caller, 'fft direction unknown.')
        GOTO 9999
    END IF

    CALL pmlib_mesh_map(topo_send,topo_recieve,2*nvar,ierr)
    CALL pmlib_comm_pack(mesh_fft,ierr)
    CALL pmlib_comm_unpack(topo_recieve,mesh_fft,ierr)
    CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Do FFTs
!---------------------------------------------------------------------------
    IF(fft_seq(m) .EQ. 1)THEN ! FFT x-pencils

      ncell = topo_recieve%ncell
      nfft  = ncell(1)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(fft_in(nfft), fft_out(nfft))

      DO j = 1, ncell(2)
        DO l = 1,nvar

! Store fft pencil
          IF(PRESENT(fft_shift) .AND. fft_shift)THEN
            DO i = 1, nfft/2
              fft_in(i) = mesh_fft(l,i + nfft/2,j)
            END DO
            DO i = nfft/2 + 1, nfft
              fft_in(i) = mesh_fft(l,i - nfft/2,j)
            END DO
          ELSE
            DO i = 1, nfft
              fft_in(i) = mesh_fft(l,i,j)
            END DO
          END IF
! Fourier transform
          CALL fft( fft_in, fft_out, nfft )
! Store mesh
          DO i = 1, ncell(1)
            mesh_fft(l,i,j) = fft_out(i)
          END DO

        END DO !l
      END DO !j

    ELSEIF(fft_seq(m) .EQ. 2)THEN ! FFT y-pencils

      ncell = topo_recieve%ncell
      nfft  = ncell(2)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(fft_in(nfft), fft_out(nfft))

      DO i = 1, ncell(1)
        DO l = 1,nvar

! Store fft pencil
          IF(PRESENT(fft_shift) .AND. fft_shift)THEN
            DO j = 1, nfft/2
              fft_in(j) = mesh_fft(l,i,j + nfft/2)
            END DO
            DO j = nfft/2 + 1, nfft
              fft_in(j) = mesh_fft(l,i,j - nfft/2)
            END DO
          ELSE
            DO j = 1, nfft
              fft_in(j) = mesh_fft(l,i,j)
            END DO
          END IF
! Fourier transform
          CALL fft( fft_in, fft_out, nfft )
! Store mesh
          DO j = 1, ncell(2)
            mesh_fft(l,i,j) = fft_out(j)
          END DO

        END DO !l
      END DO !i

    END IF ! fft direction

    DEALLOCATE(fft_in, fft_out)

!---------------------------------------------------------------------------
! Shift topology reciever to sender
!---------------------------------------------------------------------------
    topo_send = topo_recieve

  END DO ! fft_seq
 100 CONTINUE

!---------------------------------------------------------------------------
! Map to the output topology
!---------------------------------------------------------------------------
  CALL pmlib_mesh_map(topo_send,topo_out,2*nvar,ierr)
  CALL pmlib_comm_pack(mesh_fft,ierr)
  CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
  CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Deallocate local pointers
!---------------------------------------------------------------------------

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_fft






!---------------------------------------------------------------------------
! Fast Fourier transform
! This subroutine is based on the implementation of the Glassman general
! N fft given by:
! W. E. Ferguson: 
! "A simple derivation of Glassman's general N fast  Fourier transform", 
!  Comp. & Math. With Appls. 1982
!---------------------------------------------------------------------------
SUBROUTINE fft(fft_in,fft_out,nfft)

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  COMPLEX(MKC),DIMENSION(:),POINTER,INTENT(IN)  :: fft_in
  INTEGER,INTENT(IN)                            :: nfft
  COMPLEX(MKC),DIMENSION(:),POINTER,INTENT(OUT) :: fft_out

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  REAL(MK)                               :: PI
  INTEGER                                :: i, a, b, c
  LOGICAL                                :: inu

  COMPLEX(MKC)                           :: delta, omega, sumation 
  REAL(MK)                               :: angle
  INTEGER                                :: ia, ib, ic, jc, jrc

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  PI = ACOS(-1.0_MK)

  IF( ASSOCIATED(fft_out) )THEN
    IF( SIZE(fft_out,1) .NE. nfft )THEN
      DEALLOCATE( fft_out )
      ALLOCATE( fft_out(nfft) ) 
    END IF
  ELSE
    ALLOCATE( fft_out(nfft) ) 
  END IF

  IF( ASSOCIATED(fft_tmp) )THEN
    IF( SIZE(fft_tmp,1) .NE. nfft )THEN
      DEALLOCATE( fft_tmp )
      ALLOCATE( fft_tmp(nfft) ) 
    END IF
  ELSE
    ALLOCATE( fft_tmp(nfft) ) 
  END IF

  DO i = 1,nfft
    IF( i .LE. SIZE(fft_in) )THEN
      fft_out(i) = fft_in(i)
    ELSE
      fft_out(i) = CMPLX(0.0_MK,0.0_MK,MKC)
    END IF
  END DO

  a = 1
  b = nfft
  c = 1
  inu = .TRUE.

 10 CONTINUE

  IF (b .GT. 1)THEN
    GO TO 30
  END IF

  IF(inu)THEN
    GO TO 9999
  END IF

  DO i = 1,nfft
    fft_out(i) = fft_tmp(i)
  END DO

  GO TO 9999

 30 CONTINUE
  
  a = c*a
  DO c = 2,b
    IF(MOD(b,c) .EQ. 0)THEN
      GO TO 50
    END IF
  END DO

 50 CONTINUE

  b = b/c

  angle = 2.0_MK*PI/REAL(a*c,MK)

  delta = CMPLX(COS(ANGLE),-SIN(ANGLE),MKC)

  omega = CMPLX(1.0_MK, 0.0_MK,MKC)

  IF( inu )THEN

    DO ic = 1,c
      DO ia = 1,a
        DO ib = 1,b
          sumation = fft_out(ib + b*(c - 1) + b*c*(ia - 1) )
          DO jrc = 2,c
            jc = c + 1 - jrc
            sumation = fft_out(ib + b*(jc - 1) + b*c*(ia - 1) ) + omega * sumation
          END DO
          fft_tmp(ib + b*(ia - 1) + b*a*(ic - 1) ) = sumation
        END DO
        omega = delta *omega
      END DO
    END DO

  ELSE

    DO ic = 1,c
      DO ia = 1,a
        DO ib = 1,b
          sumation = fft_tmp(ib + b*(c - 1) + b*c*(ia - 1) )
          DO jrc = 2,c
            jc = c+1-jrc
            sumation = fft_tmp(ib + b*(jc - 1) + b*c*(ia - 1) ) + omega * sumation
          END DO
          fft_out(ib + b*(ia - 1) + b*a*(ic - 1) ) = sumation
        END DO
        omega = delta *omega
      END DO
    END DO
  END IF

  inu = .NOT.inu

  GO TO 10

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
9999 CONTINUE

RETURN
END SUBROUTINE fft

!---------------------------------------------------------------------------
! pmlib_fourier_ifft_mkl.f
!   version: 2D single-core
!---------------------------------------------------------------------------
! <<HEADER>>
!---------------------------------------------------------------------------
SUBROUTINE pmlib_ifft( topo_all,topo_in,mesh_fft,topo_out,mesh,ifft_seq, & 
                     & ierr, fft_shift)

USE MKL_DFTI

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology_all)                        :: topo_all
  TYPE(class_topology)                            :: topo_in
  TYPE(class_topology)                            :: topo_out
  COMPLEX(MKC),DIMENSION(:,:,:),POINTER           :: mesh_fft
  INTEGER, DIMENSION(pmlib_ndim), INTENT(IN)      :: ifft_seq
  LOGICAL, OPTIONAL, INTENT(IN)                   :: fft_shift
  REAL(MK),DIMENSION(:,:,:),POINTER               :: mesh
  INTEGER, INTENT(OUT)                            :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=10)                 :: caller = 'pmlib_ifft'
  INTEGER                           :: i,j,k,l,m

  INTEGER, DIMENSION(pmlib_ndim)    :: ncell
  INTEGER, DIMENSION(2*pmlib_ndim)  :: nghost
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin, xmax, dx 

  INTEGER                           :: nvar
  INTEGER                           :: nfft

  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft_inout  => NULL()

  TYPE(class_topology)              :: topo_send
  TYPE(class_topology)              :: topo_recieve

  type(DFTI_DESCRIPTOR), POINTER    :: mkl_desc_handle

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0
  nvar = SIZE(mesh,1)


!---------------------------------------------------------------------------
! Inverse Fourier transform
!---------------------------------------------------------------------------
  DO m = 1,pmlib_ndim
     IF(ifft_seq(m) .EQ. 0)THEN
        GOTO 100
     END IF

!---------------------------------------------------------------------------
! Map topology to the fft direction
!---------------------------------------------------------------------------
     IF(m .EQ. 1)THEN
        topo_send = topo_in
     END IF

     IF(ifft_seq(m) .EQ. 1)THEN
        topo_recieve = topo_all%xpencil
     ELSEIF(ifft_seq(m) .EQ. 2)THEN
        topo_recieve = topo_all%ypencil
     ELSE
        ierr = -1
        CALL pmlib_write(caller, 'ifft direction unknown.')
        GOTO 9999
     END IF

     CALL pmlib_mesh_map(topo_send,topo_recieve,2*nvar,ierr)
     CALL pmlib_comm_pack(mesh_fft,ierr)
     CALL pmlib_comm_unpack(topo_recieve,mesh_fft,ierr)
     CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Do IFFTs
!---------------------------------------------------------------------------
     IF(ifft_seq(m) .EQ. 1)THEN ! IFFT x-pencils

        dx    = topo_recieve%dx
        ncell = topo_recieve%ncell
        nfft  = ncell(1)
        IF(MOD(nfft,2) .NE. 0)THEN
           ierr = -1
           CALL pmlib_write(caller, 'nfft is an odd number.')
           GOTO 9999
        END IF

! Setup a complex to complex in-place transform
#ifdef __single
! Single precision
    ierr = DftiCreateDescriptor(mkl_desc_handle, DFTI_SINGLE, &
          & DFTI_COMPLEX, 1, nfft) 
#elif __double
! Double precision
    ierr = DftiCreateDescriptor(mkl_desc_handle, DFTI_DOUBLE, &
         & DFTI_COMPLEX, 1, nfft) 
#endif
        IF (ierr .NE. 0) THEN
           CALL pmlib_write(caller,'Failed to create fft.')
           GOTO 9999
        ENDIF
        ierr = DftiCommitDescriptor(mkl_desc_handle)
        IF (ierr .NE. 0) THEN
           CALL pmlib_write(caller,'Failed to commit fft.')
           GOTO 9999
        ENDIF

        ALLOCATE(ifft_inout(nfft))

        DO j = 1, ncell(2)
           DO l = 1,nvar

! Store fft pencil
              IF(PRESENT(fft_shift) .AND. fft_shift)THEN
                 DO i = 1, nfft/2
                    ifft_inout(i) = mesh_fft(l,i + nfft/2,j)
                 END DO
                 DO i = nfft/2 + 1, nfft
                    ifft_inout(i) = mesh_fft(l,i - nfft/2,j)
                 END DO
              ELSE
                 DO i = 1, nfft
                    ifft_inout(i) = mesh_fft(l,i,j)
                 END DO
              END IF

! Fourier inverse transform (overwrites fft_inout)
              ierr = DftiComputeBackward(mkl_desc_handle, ifft_inout)
              IF (ierr .NE. 0) THEN
                 CALL pmlib_write(caller,'Failed to fft.')
                 GOTO 9999
              ENDIF

! Store kernel
              DO i = 1, ncell(1)
                 mesh_fft(l,i,j) = ifft_inout(i)/REAL(nfft,MK)
              END DO

           END DO!l
        END DO!j

     ELSEIF(ifft_seq(m) .EQ. 2)THEN ! IFFT y-pencils

        dx     = topo_recieve%dx
        ncell  = topo_recieve%ncell
        nfft = ncell(2)
        IF(MOD(nfft,2) .NE. 0)THEN
           ierr = -1
           CALL pmlib_write(caller, 'nfft is an odd number.')
           GOTO 9999
        END IF

! Setup a complex to complex in-place transform
#ifdef __single
! Single precision
    ierr = DftiCreateDescriptor(mkl_desc_handle, DFTI_SINGLE, &
          & DFTI_COMPLEX, 1, nfft) 
#elif __double
! Double precision
    ierr = DftiCreateDescriptor(mkl_desc_handle, DFTI_DOUBLE, &
         & DFTI_COMPLEX, 1, nfft) 
#endif
        IF (ierr .NE. 0) THEN
           CALL pmlib_write(caller,'Failed to create fft.')
           GOTO 9999
        ENDIF
        ierr = DftiCommitDescriptor(mkl_desc_handle)
        IF (ierr .NE. 0) THEN
           CALL pmlib_write(caller,'Failed to commit fft.')
           GOTO 9999
        ENDIF

        ALLOCATE(ifft_inout(nfft))

        DO i = 1, ncell(1)
           DO l = 1,nvar

! Store fft pencil
              IF(PRESENT(fft_shift) .AND. fft_shift)THEN
                 DO j = 1, nfft/2
                    ifft_inout(j) = mesh_fft(l,i,j + nfft/2)
                 END DO
                 DO j = nfft/2 + 1, nfft
                    ifft_inout(j) = mesh_fft(l,i,j - nfft/2)
                 END DO
              ELSE
                 DO j = 1, nfft
                    ifft_inout(j) = mesh_fft(l,i,j)
                 END DO
              END IF

! Fourier inverse transform (overwrites fft_inout)
              ierr = DftiComputeBackward(mkl_desc_handle, ifft_inout)
              IF (ierr .NE. 0) THEN
                 CALL pmlib_write(caller,'Failed to fft.')
                 GOTO 9999
              ENDIF

! Store kernel
              DO j = 1, ncell(2)
                 mesh_fft(l,i,j) = ifft_inout(j)/REAL(nfft,MK)
              END DO

           END DO ! l
        END DO ! i

     END IF ! fft direction

! Clean up mkl
     ierr = DftiFreeDescriptor(mkl_desc_handle)
     IF (ierr .NE. 0) THEN
        CALL pmlib_write(caller,'Failed to free fft.')
        GOTO 9999
     ENDIF

     DEALLOCATE(ifft_inout)

!---------------------------------------------------------------------------
! Shift topology reciever to sender
!---------------------------------------------------------------------------
     topo_send = topo_recieve

  END DO! fft_seq
100 CONTINUE

!---------------------------------------------------------------------------
! Map to the output topology
!---------------------------------------------------------------------------
  CALL pmlib_mesh_map(topo_send,topo_out,2*nvar,ierr)
  CALL pmlib_comm_pack(mesh_fft,ierr)
  CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
  CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Map boundaries
!---------------------------------------------------------------------------
  DO i = 1,pmlib_ndim
     CALL pmlib_mesh_map_ghost(topo_out,i,2*nvar,ierr)
     CALL pmlib_comm_pack(mesh_fft,ierr)
     CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
     CALL pmlib_comm_finalise(ierr)
  END DO

!---------------------------------------------------------------------------
! Allocate the real mesh and extract the real part of the complex mesh
!---------------------------------------------------------------------------
  ncell  = topo_out%ncell
  nghost = topo_out%nghost

  IF( ASSOCIATED(mesh) ) THEN
     DEALLOCATE(mesh,stat=ierr)
     IF (ierr .NE. 0) THEN
        CALL pmlib_write(caller,'Failed to deallocate array.')
        GOTO 9999
     ENDIF
  END IF

  ALLOCATE(mesh(nvar, &
       & 1-nghost(1):ncell(1)+nghost(2), &
       & 1-nghost(3):ncell(2)+nghost(4)), &
       & stat=ierr)
  IF (ierr .NE. 0) THEN
     CALL pmlib_write(caller,'Failed to allocate array.')
     GOTO 9999
  ENDIF

! Extract the real part
  DO j = 1 - nghost(3), ncell(2) + nghost(4)
     DO i = 1 - nghost(1), ncell(1) + nghost(2)
        DO l = 1,nvar
           mesh(l,i,j) = REAL(mesh_fft(l,i,j))
        END DO
     END DO
  END DO

!---------------------------------------------------------------------------
! Deallocate the Fourier coefficients
!---------------------------------------------------------------------------
  DEALLOCATE(mesh_fft)

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
9999 CONTINUE
  RETURN
END SUBROUTINE pmlib_ifft

!---------------------------------------------------------------------------
! pmlib_mesh.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_mesh

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

!---------------------------------------------------------------------------
! Define field class
!---------------------------------------------------------------------------
  TYPE class_mesh
! velocity (dim,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: vel => NULL()
! vorticity (dim,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: vort => NULL()
! material derivative of vorticity (dim,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: dvort => NULL()
! poisson kernel fft
    COMPLEX(MKC),DIMENSION(:,:,:),POINTER   :: pkernel_fft => NULL()

! Penalisation variables
! penalisation velocity (dim,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: vel_pen => NULL()
! characteristic function (1,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: solid => NULL()
! velocity of solid (dim,x,y)
    REAL(MK),DIMENSION(:,:,:),POINTER       :: solid_vel => NULL()
  END TYPE class_mesh

!----------------------------------------------------------------------------
! Interfaces
!----------------------------------------------------------------------------
  INTERFACE pmlib_mesh_allocate
    MODULE PROCEDURE pmlib_mesh_allocate
  END INTERFACE

CONTAINS

#include "mesh/pmlib_mesh_allocate.f"

#include "mesh/pmlib_mesh_map.f"

#include "mesh/pmlib_mesh_map_interpolation.f"

#include "mesh/pmlib_mesh_map_ghost.f"


END MODULE pmlib_mod_mesh

!---------------------------------------------------------------------------
! pmlib_poisson.f
!   version: 2D single-core
!---------------------------------------------------------------------------
! <<HEADER>>
!---------------------------------------------------------------------------
MODULE pmlib_mod_poisson

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

!----------------------------------------------------------------------------
! Interfaces
!----------------------------------------------------------------------------
  INTERFACE pmlib_poisson_setup
    MODULE PROCEDURE pmlib_poisson_setup
  END INTERFACE

  INTERFACE pmlib_poisson_solve
    MODULE PROCEDURE pmlib_poisson_solve
  END INTERFACE

CONTAINS

#include "poisson/pmlib_poisson_setup.f"

#ifdef __mkl

#include "poisson/pmlib_poisson_solve_mkl.f"

#elif __fftw

#include "poisson/pmlib_poisson_solve_fftw.f"

#else

#include "poisson/pmlib_poisson_solve.f"

#endif


END MODULE pmlib_mod_poisson

!---------------------------------------------------------------------------
! pmlib_finalise.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_finalise

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

  INTERFACE pmlib_finalise
    MODULE PROCEDURE pmlib_finalise
  END INTERFACE

CONTAINS


SUBROUTINE pmlib_finalise(part,mesh,ierr)

USE pmlib_mod_mesh
USE pmlib_mod_particles
USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_particles)                        :: part
  TYPE(class_mesh)                             :: mesh
  INTEGER, INTENT(OUT)                         :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! De-allocate particles
!---------------------------------------------------------------------------
  IF( ASSOCIATED(part%pos) ) DEALLOCATE( part%pos )
  IF( ASSOCIATED(part%vel) ) DEALLOCATE( part%vel )
  IF( ASSOCIATED(part%vort) ) DEALLOCATE( part%vort )
  IF( ASSOCIATED(part%dvort)) DEALLOCATE( part%dvort )
  IF( ASSOCIATED(part%vel_rk) ) DEALLOCATE( part%vel_rk )
  IF( ASSOCIATED(part%dvort_rk) ) DEALLOCATE( part%dvort_rk )
  IF (ierr .NE. 0) THEN
    CALL pmlib_write('pmlib_allocate_mesh','Failed to deallocate array.')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! De-allocate mesh
!---------------------------------------------------------------------------
  IF( ASSOCIATED(mesh%vel) ) DEALLOCATE( mesh%vel )
  IF( ASSOCIATED(mesh%vort) ) DEALLOCATE( mesh%vort )
  IF( ASSOCIATED(mesh%dvort) ) DEALLOCATE( mesh%dvort )
  IF( ASSOCIATED(mesh%pkernel_fft) ) DEALLOCATE(mesh%pkernel_fft)
  IF (ierr .NE. 0) THEN
    CALL pmlib_write('pmlib_allocate_mesh','Failed to deallocate array.')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN

END SUBROUTINE pmlib_finalise

END MODULE pmlib_mod_finalise

!---------------------------------------------------------------------------
! pmlib_particles.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_particles

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

!---------------------------------------------------------------------------
! Define particle class
!---------------------------------------------------------------------------
  TYPE class_particles
! position (dim,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: pos => NULL()
! velocity (dim,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: vel => NULL()
! vorticity (ncom,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: vort => NULL()
! material derivative of vorticity (ncom,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: dvort => NULL()

! substep velocity (dim,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: vel_rk => NULL()
! substep material derivative of vorticity (ncom,ipart)
    REAL(MK),DIMENSION(:,:),POINTER :: dvort_rk => NULL()
  END TYPE class_particles

!----------------------------------------------------------------------------
! Interfaces
!----------------------------------------------------------------------------
  INTERFACE pmlib_particles_advance
    MODULE PROCEDURE pmlib_particles_advance
  END INTERFACE

CONTAINS

#include "particles/pmlib_particles_map.f"

#include "particles/pmlib_particles_advance.f"

END MODULE pmlib_mod_particles

!---------------------------------------------------------------------------
! pmlib_mesh_map_interpolation.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_mesh_map_interpolation(topo,dir,nvar_send,ierr)

!---------------------------------------------------------------------------
! Sets up the mesh boundary communication for superposition 
! of the interpolated mesh
!  - Finds the overlapping mesh indices
!  - Finds the communication sequence
!  - Allocates the send and recieve buffers
!
! The communication is calculated on processor 0 only
! after which it is broadcasted to the remaining processors.
!---------------------------------------------------------------------------

USE pmlib_mod_communication
USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology)                      :: topo
  INTEGER, INTENT(IN)                       :: dir
  INTEGER, INTENT(IN)                       :: nvar_send
  INTEGER, INTENT(OUT)                      :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=22)                     :: caller = 'pmlib_comm_boundaries'
  INTEGER                               :: ncomm, icomm
  INTEGER                               :: iproc, jproc
  INTEGER                               :: i,j,k

  INTEGER                               :: ineigh, neigh
  REAL(MK), DIMENSION(pmlib_ndim)       :: xmin_send, xmax_send
  REAL(MK), DIMENSION(pmlib_ndim)       :: xmin_recieve, xmax_recieve
  REAL(MK), DIMENSION(pmlib_ndim)       :: dx

  INTEGER,DIMENSION(2*pmlib_ndim)       :: nghost_recieve, nghost_send
  INTEGER, DIMENSION(pmlib_ndim)        :: ncell_send, ncell_recieve
  INTEGER                               :: nghost, ncell

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! Find number of communications
!---------------------------------------------------------------------------
  icomm = 0
  DO ineigh = 2*dir-1,2*dir
    
    neigh = topo%ineigh(ineigh)

    IF( neigh .NE. -1 )THEN
      nghost_send    = topo%nghost
      nghost_recieve = topo%nghost

      IF( ( nghost_send(ineigh) .GT. 0 ) .OR. &
        & ( ineigh .EQ. 2*dir-1 .AND.  nghost_recieve(2*dir) .GT. 0 ) .OR. &
        & ( ineigh .EQ. 2*dir   .AND. nghost_recieve(2*dir-1) .GT. 0 ) )THEN
        icomm = icomm + 1
      END IF
    END IF ! neighbours

  END DO !ineigh

!---------------------------------------------------------------------------
! Allocate communication lists
!---------------------------------------------------------------------------
  ncomm               = icomm
  communication%ncomm = ncomm
  communication%ctype = 2

  ALLOCATE( communication%imin_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imax_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imin_recieve(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imax_recieve(pmlib_ndim,ncomm) )

  ALLOCATE( communication%ncell_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%ncell_recieve(pmlib_ndim,ncomm) )

!---------------------------------------------------------------------------
! Loop through neighbours
!---------------------------------------------------------------------------
  icomm = 0
  DO ineigh = 2*dir-1,2*dir
    
    neigh = topo%ineigh(ineigh)

    IF( neigh .NE. -1 )THEN
      nghost_send    = topo%nghost
      nghost_recieve = topo%nghost

      IF( ( nghost_send(ineigh) .GT. 0 ) .OR. &
        & ( ineigh .EQ. 2*dir-1 .AND.   nghost_recieve(2*dir) .GT. 0 ) .OR. &
        & ( ineigh .EQ. 2*dir   .AND. nghost_recieve(2*dir-1) .GT. 0 ) )THEN

!---------------------------------------------------------------------------
! Count communications
!---------------------------------------------------------------------------
        icomm = icomm + 1

!---------------------------------------------------------------------------
! Store number of mesh cells in the topologies
!---------------------------------------------------------------------------
        ncell_send     = topo%ncell
        ncell_recieve  = topo%ncell

!---------------------------------------------------------------------------
! Find indices of ghost cells
!---------------------------------------------------------------------------
        DO i = 1,pmlib_ndim

          IF(2*i-1 .EQ. ineigh)THEN

            communication%imin_send(i,icomm)    = 1 - nghost_send(2*i-1)
            communication%imin_recieve(i,icomm) = ncell_recieve(i) + 1 &
                                              & - nghost_send(2*i-1)

            communication%imax_send(i,icomm)    = nghost_recieve(2*i)
            communication%imax_recieve(i,icomm) = ncell_recieve(i) &
                                              & + nghost_recieve(2*i)

          ELSEIF(2*i .EQ. ineigh)THEN

            communication%imin_send(i,icomm)    = ncell_send(i) &
                                              & - nghost_recieve(2*i-1) + 1
            communication%imin_recieve(i,icomm) = 1 - nghost_recieve(2*i-1)

            communication%imax_send(i,icomm)    = ncell_send(i) &
                                              & + nghost_send(2*i)
            communication%imax_recieve(i,icomm) = nghost_send(2*i)

          ELSE
            ncell  = MIN(ncell_send(i),ncell_recieve(i))

            nghost = MIN(nghost_send(2*i-1),nghost_recieve(2*i-1))
            communication%imin_send(i,icomm)    = 1 - nghost
            communication%imin_recieve(i,icomm) = 1 - nghost

            nghost = MIN(nghost_send(2*i),nghost_recieve(2*i))
            communication%imax_send(i,icomm)    = ncell + nghost
            communication%imax_recieve(i,icomm) = ncell + nghost
          END IF

          communication%ncell_send(i,icomm) = &
                   & communication%imax_send(i,icomm) - &
                   &  communication%imin_send(i,icomm) + 1
      
          communication%ncell_recieve(i,icomm) = &
                   & communication%imax_recieve(i,icomm) - &
                   &  communication%imin_recieve(i,icomm) + 1

! check if the number of sended and recieved cells coinside
          IF(  communication%ncell_send(i,icomm) .NE. &
            &  communication%ncell_recieve(i,icomm))THEN
            ierr = -1
            CALL pmlib_write( caller, &
                & 'Number of sended and recieved cells does not correspond')
            GOTO 9999
          END IF

        END DO

      END IF ! nghost
    END IF ! neighbours

  END DO !ineigh

!---------------------------------------------------------------------------
! Check number of communications
!---------------------------------------------------------------------------
  IF(icomm .NE. ncomm)THEN
    ierr = -1
    CALL pmlib_write(caller,'Number of communications are inconsistent')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! Allocate communication buffer
!---------------------------------------------------------------------------
  IF( ASSOCIATED(comm_buffer) ) THEN
    DEALLOCATE(comm_buffer)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF 
  ALLOCATE( comm_buffer(ncomm) )

  DO j = 1,ncomm

    ncell_send(1) = communication%ncell_send(1,j)  
    ncell_send(2) = communication%ncell_send(2,j)
 
! Allocate send array for communication j
    ALLOCATE( comm_buffer(j)%mesh_send(nvar_send, &
            & ncell_send(1),ncell_send(2)) )
    comm_buffer(j)%nsend = nvar_send*ncell_send(1)*ncell_send(2)
    comm_buffer(j)%ncell_send = ncell_send

! Allocate recieve array for communication j
    ALLOCATE( comm_buffer(j)%mesh_recieve(nvar_send, &
            & ncell_send(1),ncell_send(2)) )
    comm_buffer(j)%nrecieve = nvar_send*ncell_send(1)*ncell_send(2)
    comm_buffer(j)%ncell_recieve = ncell_send

  END DO

!---------------------------------------------------------------------------
! set counter for number of packed variables
!---------------------------------------------------------------------------
  communication%npacked = 0

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_mesh_map_interpolation

!--------------------------------------------------------------------------!
! client_output.f
!--------------------------------------------------------------------------!
!                                  ___   __                                !
!                  __    __       / _ \ / /           _/\_                 !
!    ___  _ _     / /__ / /      / / \// /__ ___ _ _ /  _/                 !
!   | _ \/ ` \ _ / // // _ \ *   \ \/\/ // // -_/ ' \/ /                   !
!   | ,_/_,_,_\  \_/\_/\___/ *    \__/\_/\_/\__//_/_/\_/                   !
!   |_|                                                                    !
!                            Mads M. Hejlesen* and Jens H. Walther*^       !
!                            * Technical University of Denmark             !
!                            ^ ETH-Zurich                                  !
!                                                                          !
!--------------------------------------------------------------------------!
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE client_mod_output

USE client_mod_parameters

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

CONTAINS

SUBROUTINE client_output_plot(tag,topo,mesh,max_val,ierr)

USE client_mod_penalisation

USE pmlib_mod_communication
USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! arguments
!---------------------------------------------------------------------------
  CHARACTER(LEN=*), INTENT(IN)                    :: tag
  TYPE(class_topology)                            :: topo
  REAL(MK), DIMENSION(:,:,:),POINTER, INTENT(IN)  :: mesh
  REAL(MK), INTENT(IN)                            :: max_val 
  INTEGER, INTENT(OUT)                            :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=5)                                :: background
  INTEGER, PARAMETER                              :: IO_unit_ps = 10
  CHARACTER(LEN=256)                              :: outfile
  INTEGER                                         :: ltag
  INTEGER                                         :: i,j,k,l
  REAL(SELECTED_REAL_KIND(22))                    :: base10
  INTEGER,DIMENSION(4)                            :: b
  INTEGER,DIMENSION(5)                            :: c
  CHARACTER(LEN=5)                                :: asc
  INTEGER                                         :: lasc, lline

  INTEGER                                         :: nvar
  REAL(MK)                                        :: var_mag

  INTEGER,DIMENSION(:),POINTER                    :: rgb
  INTEGER,DIMENSION(2)                            :: npixel

  REAL(MK), DIMENSION(:,:,:),POINTER              :: solid

  REAL(MK)                                        :: px,py

  REAL(MK),DIMENSION(ndim)                     :: xmin, dx
  INTEGER,DIMENSION(ndim)                      :: ncell
  INTEGER,DIMENSION(2*ndim)                    :: nghost

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0
!  background = "black"
  background = "white"

!---------------------------------------------------------------------------
! find number of pixels
!---------------------------------------------------------------------------
  nvar   = SIZE(mesh,1)
  npixel = topo%ncell

!---------------------------------------------------------------------------
! Map penalisation mask to mesh
!---------------------------------------------------------------------------
  ALLOCATE( solid(1, &
          & 1-topo%nghost(1):topo%ncell(1)+topo%nghost(2), &
          & 1-topo%nghost(3):topo%ncell(2)+topo%nghost(4)), &
          & stat=ierr)
  solid = 0.0_MK
  IF(penalisation)THEN
    CALL pmlib_mesh_map(topo_penal%cuboid,topo,1,ierr)
    CALL pmlib_comm_pack(mesh_penal%solid,ierr)
    CALL pmlib_comm_unpack(topo,solid,ierr)
    CALL pmlib_comm_finalise(ierr)
  END IF

!---------------------------------------------------------------------------
! Re-size to 1D array
!---------------------------------------------------------------------------
  ALLOCATE( rgb(3*npixel(1)*npixel(2)) )
  l = 0

  SELECT CASE ( TRIM(background) )
    CASE ('black')
      DO k = 1,npixel(2)
        DO j = 1,npixel(1)

          IF(nvar .EQ. 1)THEN
            var_mag = mesh(1,j,k)
          ELSE
            var_mag = 0.0_MK
            DO i = 1,nvar
              var_mag = var_mag + mesh(i,j,k)**2
            END DO
            var_mag = SQRT(var_mag)
          END IF

          IF(solid(1,j,k) .NE. 0.0_MK)THEN
            l = l + 1
            rgb(l) = 51
            l = l + 1
            rgb(l) = 51
            l = l + 1
            rgb(l) = 51 
          ELSE
            IF( var_mag .GT. 0.0_MK)THEN
              l = l + 1
              rgb(l) = FLOOR(MIN( ABS( var_mag)/max_val &
                                      & * 255.0_MK, 255.0_MK) )
              l = l + 1
              rgb(l) = 0
              l = l + 1
              rgb(l) = 0
            ELSEIF( var_mag .LT. 0.0_MK)THEN
              l = l + 1
              rgb(l) = 0
              l = l + 1
              rgb(l) = 0
              l = l + 1
              rgb(l) = FLOOR(MIN( ABS( var_mag)/max_val &
                                     & * 255.0_MK, 255.0_MK))
            ELSE
              l = l + 1
              rgb(l) = 0
              l = l + 1
              rgb(l) = 0
              l = l + 1
              rgb(l) = 0
            END IF
          END IF
        END DO
      END DO

    CASE ('white')
      DO k = 1,npixel(2)
        DO j = 1,npixel(1)
 
          IF(nvar .EQ. 1)THEN
            var_mag = mesh(1,j,k)
          ELSE
            var_mag = 0.0_MK
            DO i = 1,nvar
              var_mag = var_mag + mesh(i,j,k)**2
            END DO
            var_mag = SQRT(var_mag)
          END IF

          IF(solid(1,j,k) .NE. 0.0_MK)THEN
            l = l + 1
            rgb(l) = 51
            l = l + 1
            rgb(l) = 51
            l = l + 1
            rgb(l) = 51 
          ELSE

            IF( var_mag .GT. 0.0_MK)THEN
              l = l + 1
              rgb(l) = 255
              l = l + 1
              rgb(l) = 255 - FLOOR(MIN( ABS( var_mag)/max_val &
                                      & * 255.0_MK, 255.0_MK) )
              l = l + 1
              rgb(l) = 255 - FLOOR(MIN( ABS( var_mag)/max_val & 
                                      & * 255.0_MK, 255.0_MK))
            ELSEIF( var_mag .LT. 0.0_MK)THEN
              l = l + 1
              rgb(l) = 255 - FLOOR(MIN( ABS( var_mag)/max_val &
                                      & * 255.0_MK, 255.0_MK))
              l = l + 1
              rgb(l) = 255 - FLOOR(MIN( ABS( var_mag)/max_val &
                                      & * 255.0_MK, 255.0_MK))
              l = l + 1
              rgb(l) = 255
            ELSE
              l = l + 1
              rgb(l) = 255
              l = l + 1
              rgb(l) = 255
              l = l + 1
              rgb(l) = 255
            END IF

          END IF
        END DO
      END DO
  END SELECT

!---------------------------------------------------------------------------
! Write window to eps file
!---------------------------------------------------------------------------
  WRITE(outfile,'(A,A)') TRIM(tag),'.ps'

!---------------------------------------------------------------------------
! Write postscript file
!---------------------------------------------------------------------------
  OPEN(IO_unit_ps,FILE=outfile,FORM='FORMATTED')

  WRITE(IO_unit_ps,'(A)') '%!PS-Adobe-2.0 EPSF-2.0'
  WRITE(IO_unit_ps,'(A,2I6)') '%%BoundingBox: 0 0 ',npixel(1),npixel(2)
  WRITE(IO_unit_ps,'(A)')''
  WRITE(IO_unit_ps,'(A)')'/DeviceRGB setcolorspace'
  WRITE(IO_unit_ps,'(A)')'gsave'
  WRITE(IO_unit_ps,'(A)')''
  WRITE(IO_unit_ps,'(A)') '%%%%BeginImage'
  WRITE(IO_unit_ps,'(A)') '0 0 translate'
  WRITE(IO_unit_ps,'(2I6,A)') npixel(1),npixel(2),' scale'
  WRITE(IO_unit_ps,'(A)') '<<'
  WRITE(IO_unit_ps,'(A)') '  /ImageType 1'
  WRITE(IO_unit_ps,'(A,I6)') '  /Width', npixel(1)
  WRITE(IO_unit_ps,'(A,I6)') '  /Height', npixel(2)
  WRITE(IO_unit_ps,'(A)') '  /BitsPerComponent 8'
  WRITE(IO_unit_ps,'(A,2(I6,A))') '  /ImageMatrix [ ', &
                        & npixel(1), ' 0 0 ', npixel(2), ' 0 0 ]'
  WRITE(IO_unit_ps,'(A)') '  /Decode [ 0 1 0 1 0 1 ]'
  WRITE(IO_unit_ps,'(A)') '  /DataSource currentfile /ASCII85Decode filter'
  WRITE(IO_unit_ps,'(A)') '  /MultipleDataSources false'
  WRITE(IO_unit_ps,'(A)') '  /Interpolate true'
  WRITE(IO_unit_ps,'(A)') '>>'
  WRITE(IO_unit_ps,'(A)') 'image'

!---------------------------------------------------------------------------
! Encode to ASCII85
!---------------------------------------------------------------------------
  lline = 0
  b = 0
  c = 0
  DO i = 1,CEILING(REAL(3*npixel(1)*npixel(2),MK)/4.0_MK)

    DO j = 1,4
      IF( 4*i-4+j .LE. 3*npixel(1)*npixel(2) )THEN
        b(5-j) = rgb(4*i-4+j)
      ELSE
        b(5-j) = 0
      END IF
    END DO

    base10 = REAL(b(1),MK)
    base10 = base10 + REAL(b(2),MK)*256
    base10 = base10 + REAL(b(3),MK)*(256**2)
    base10 = base10 + REAL(b(4),MK)*(256**3)

    DO j = 1,5
      c(6-j) = INT(MAX(0.0_MK, base10 - 85.0_MK*AINT(base10/85.0_MK) ))
      base10 = AINT(base10/85.0_MK)
    END DO

    IF( c(1) .EQ. 0 .AND. c(2) .EQ. 0 .AND. &
      & c(3) .EQ. 0 .AND. c(4) .EQ. 0 .AND. c(5) .EQ. 0)THEN
      WRITE(asc,'(A)') 'z'
      lasc = 1
    ELSE
      WRITE(asc,'(5A)') CHAR(c(1)+33),CHAR(c(2)+33), &
                      & CHAR(c(3)+33),CHAR(c(4)+33),CHAR(c(5)+33)
      lasc = 5
    END IF

    IF(lline .GT. 77)THEN
      WRITE(IO_unit_ps,'(A)',ADVANCE='YES') asc(1:lasc)
      lline = 0
    ELSE
      WRITE(IO_unit_ps,'(A)',ADVANCE='NO') asc(1:lasc)
      lline = lline + lasc
    END IF

  ENDDO

  WRITE(IO_unit_ps,'(A)',ADVANCE='YES')''
  WRITE(IO_unit_ps,'(A)')'~>'
  WRITE(IO_unit_ps,'(A)') '%%%%EndImage'
  WRITE(IO_unit_ps,'(A)') 'grestore' 
  WRITE(IO_unit_ps,'(A)') 'showpage'
  WRITE(IO_unit_ps,'(A)')'%%EOF'

  CLOSE(IO_unit_ps)

!---------------------------------------------------------------------------
! De-allocate local pointers
!---------------------------------------------------------------------------
  DEALLOCATE( rgb )
  DEALLOCATE( solid )

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN

END SUBROUTINE client_output_plot


END MODULE client_mod_output

!---------------------------------------------------------------------------
! pmlib_mesh_map.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_mesh_map(topo_send,topo_recieve,nvar_send,ierr)

!---------------------------------------------------------------------------
! Sets up the inter topology mesh communication
!  - Finds the overlapping mesh indices
!  - Finds the communication sequence
!  - Allocates the send and recieve buffers
!
! The communication is calculated on processor 0 only
! after which it is broadcasted to the remaining processors.
!---------------------------------------------------------------------------

USE pmlib_mod_communication
USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology)                      :: topo_send
  TYPE(class_topology)                      :: topo_recieve
  INTEGER, INTENT(IN)                       :: nvar_send
  INTEGER, INTENT(OUT)                      :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=14)                     :: caller = 'pmlib_mesh_map'
  INTEGER                               :: ncomm, icomm
  INTEGER                               :: iproc, jproc
  INTEGER                               :: i,j,k

  REAL(MK), DIMENSION(pmlib_ndim)       :: xmin_send, xmax_send
  REAL(MK), DIMENSION(pmlib_ndim)       :: xmin_recieve, xmax_recieve
  REAL(MK), DIMENSION(pmlib_ndim)       :: dx
  INTEGER,DIMENSION(2*pmlib_ndim)       :: nghost_recieve, nghost_send
  INTEGER,DIMENSION(2*pmlib_ndim)       :: bc_send, bc_recieve
  INTEGER                               :: nghost
  INTEGER, DIMENSION(pmlib_ndim)        :: ncell_send, ncell_recieve


!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! Allocate communication lists
!---------------------------------------------------------------------------
  ncomm               = 1
  communication%ncomm = 1
  communication%ctype = 1

  ALLOCATE( communication%imin_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imax_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imin_recieve(pmlib_ndim,ncomm) )
  ALLOCATE( communication%imax_recieve(pmlib_ndim,ncomm) )

  ALLOCATE( communication%ncell_send(pmlib_ndim,ncomm) )
  ALLOCATE( communication%ncell_recieve(pmlib_ndim,ncomm) )

!---------------------------------------------------------------------------
! Subdomain parameters
!---------------------------------------------------------------------------
  xmin_send      = topo_send%xmin
  xmax_send      = topo_send%xmax

  xmin_recieve   = topo_recieve%xmin
  xmax_recieve   = topo_recieve%xmax

  ncell_send     = topo_send%ncell
  ncell_recieve  = topo_recieve%ncell

  nghost_send    = topo_send%nghost
  nghost_recieve = topo_recieve%nghost

  bc_send        = topo_send%bound_cond
  bc_recieve     = topo_recieve%bound_cond

  dx = topo_recieve%dx

!---------------------------------------------------------------------------
! Check overlap
!---------------------------------------------------------------------------
  IF( NINT( (xmax_recieve(1) - xmin_send(1))/dx(1) ) .GT. 0 .AND. &
    & NINT( (xmax_recieve(2) - xmin_send(2))/dx(2) ) .GT. 0 .AND. &
    & NINT( (xmax_send(1) - xmin_recieve(1))/dx(1) ) .GT. 0 .AND. &
    & NINT( (xmax_send(2) - xmin_recieve(2))/dx(2) ) .GT. 0 )THEN

!---------------------------------------------------------------------------
! Find indices of intersection
!---------------------------------------------------------------------------
    icomm = 1
    DO i = 1,pmlib_ndim

! min index
      IF( NINT( (xmin_recieve(i) - xmin_send(i))/dx(i) ) .EQ. 0 )THEN

        communication%imin_send(i,icomm)    = 1
        communication%imin_recieve(i,icomm) = 1

      ELSEIF( NINT( (xmin_send(i) - xmin_recieve(i))/dx(i) ) .GT. 0 )THEN

        communication%imin_send(i,icomm)    = 1
        communication%imin_recieve(i,icomm) = & 
              & NINT((xmin_send(i)-xmin_recieve(i))/dx(i)) + 1

      ELSEIF( NINT( (xmin_recieve(i) - xmin_send(i))/dx(i) ) .GT. 0 .AND. &
            & bc_recieve(2*i-1) .NE. 0 )THEN

        communication%imin_send(i,icomm)    = & 
              & NINT((xmin_recieve(i)-xmin_send(i))/dx(i)) + 1
        communication%imin_recieve(i,icomm) = 1

      ELSEIF( NINT( (xmin_recieve(i) - xmin_send(i))/dx(i) ) .GT. 0 .AND. &
            & bc_recieve(2*i-1) .EQ. 0 )THEN

        nghost = MIN( nghost_recieve(2*i-1), &
               & NINT((xmin_recieve(i)-xmin_send(i))/dx(i)) &
               & + nghost_send(2*i-1) )

        communication%imin_send(i,icomm)    = & 
              & NINT((xmin_recieve(i)-xmin_send(i))/dx(i)) + 1 - nghost
        communication%imin_recieve(i,icomm) = 1 - nghost

      ELSE
        ierr = -1
        CALL pmlib_write(caller,'Failed to identify intersection indexes')
        GOTO 9999
      ENDIF


! max index
      IF( NINT( (xmax_recieve(i) - xmax_send(i))/dx(i) ) .EQ. 0 )THEN

        communication%imax_send(i,icomm)    = ncell_send(i)
        communication%imax_recieve(i,icomm) = ncell_recieve(i)

      ELSEIF( NINT( (xmax_recieve(i) - xmax_send(i))/dx(i) ) .GT. 0 )THEN

        communication%imax_send(i,icomm)    = ncell_send(i)
        communication%imax_recieve(i,icomm) = & 
              & NINT((xmax_send(i)-xmin_recieve(i))/dx(i))

      ELSEIF( NINT( (xmax_send(i) - xmax_recieve(i))/dx(i) ) .GT. 0 .AND. &
            & bc_recieve(2*i) .NE. 0)THEN

        communication%imax_send(i,icomm) = & 
              & NINT((xmax_recieve(i)-xmin_send(i))/dx(i))
        communication%imax_recieve(i,icomm) = ncell_recieve(i)

      ELSEIF( NINT( (xmax_send(i) - xmax_recieve(i))/dx(i) ) .GT. 0 .AND. &
            & bc_recieve(2*i) .EQ. 0 )THEN

        nghost = MIN( nghost_recieve(2*i), &
               & NINT((xmax_recieve(i)-xmin_send(i))/dx(i)) &
               & + nghost_send(2*i) )

        communication%imax_send(i,icomm) = & 
              & NINT((xmax_recieve(i)-xmin_send(i))/dx(i)) + nghost
        communication%imax_recieve(i,icomm) = ncell_recieve(i) + nghost

      ELSE
        ierr = -1
        CALL pmlib_write(caller,'Failed to identify intersection indexes')
        GOTO 9999
      ENDIF

      communication%ncell_send(i,icomm) = &
                   & communication%imax_send(i,icomm) - &
                   &  communication%imin_send(i,icomm) + 1
      
      communication%ncell_recieve(i,icomm) = &
                   & communication%imax_recieve(i,icomm) - &
                   &  communication%imin_recieve(i,icomm) + 1

! check if the number of sended and recieved cells coinside
      IF(  communication%ncell_send(i,icomm) .NE. &
        &  communication%ncell_recieve(i,icomm))THEN
        ierr = -1
        CALL pmlib_write(caller, &
               & 'Number of sended and recieved cells does not correspond' )
        GOTO 9999
      END IF

      IF(communication%imin_send(i,icomm) .LT. 1-nghost_send(2*i-1))THEN
        CALL pmlib_write(caller,'Sending index is too low')
      END IF
      IF(communication%imax_send(i,icomm) .GT. ncell_send(i)+nghost_send(2*i))THEN
        CALL pmlib_write(caller,'Sending index is too high')
      END IF
      IF(communication%imin_recieve(i,icomm) .LT. 1-nghost_recieve(2*i-1))THEN
        CALL pmlib_write(caller,'Recieving index is too low')
      END IF
      IF(communication%imax_recieve(i,icomm) .GT. ncell_recieve(i)+nghost_recieve(2*i))THEN
        CALL pmlib_write(caller,'Recieving index is too high')
      END IF

    END DO ! direction
  END IF ! intersecting

!---------------------------------------------------------------------------
! Allocate communication buffer
!---------------------------------------------------------------------------
  IF( ASSOCIATED(comm_buffer) ) THEN
    DEALLOCATE(comm_buffer)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF 
  ALLOCATE( comm_buffer(ncomm) )

  DO j = 1,ncomm

    ncell_send(1) = communication%ncell_send(1,j)  
    ncell_send(2) = communication%ncell_send(2,j)
 
! Allocate send array for communication j
    ALLOCATE( comm_buffer(j)%mesh_send(nvar_send, &
            & ncell_send(1),ncell_send(2)) )
    comm_buffer(j)%nsend = nvar_send*ncell_send(1)*ncell_send(2)
    comm_buffer(j)%ncell_send = ncell_send

! Allocate send array for communication j
    ALLOCATE( comm_buffer(j)%mesh_recieve(nvar_send, &
            & ncell_send(1),ncell_send(2)) )
    comm_buffer(j)%nrecieve = nvar_send*ncell_send(1)*ncell_send(2)
    comm_buffer(j)%ncell_recieve = ncell_send
  END DO

!---------------------------------------------------------------------------
! set counter for number of packed variables
!---------------------------------------------------------------------------
  communication%npacked = 0

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_mesh_map

!---------------------------------------------------------------------------
! pmlib_fourier_ifft.f
!   version: 2D single-core
!---------------------------------------------------------------------------
! <<HEADER>>
!---------------------------------------------------------------------------
SUBROUTINE pmlib_ifft( topo_all,topo_in,mesh_fft,topo_out,mesh,ifft_seq, & 
                     & ierr,fft_shift)

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology_all)                        :: topo_all
  TYPE(class_topology)                            :: topo_in
  TYPE(class_topology)                            :: topo_out
  COMPLEX(MKC),DIMENSION(:,:,:),POINTER           :: mesh_fft
  INTEGER, DIMENSION(pmlib_ndim), INTENT(IN)      :: ifft_seq
  LOGICAL, OPTIONAL, INTENT(IN)                   :: fft_shift
  REAL(MK),DIMENSION(:,:,:),POINTER               :: mesh
  INTEGER, INTENT(OUT)                            :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=10)                 :: caller = 'pmlib_ifft'
  INTEGER                           :: i,j,k,l,m

  INTEGER, DIMENSION(pmlib_ndim)    :: ncell
  INTEGER, DIMENSION(2*pmlib_ndim)  :: nghost
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin, xmax, dx 

  INTEGER                           :: nvar
  INTEGER                           :: nfft

  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: ifft_out => NULL()

  TYPE(class_topology)              :: topo_send
  TYPE(class_topology)              :: topo_recieve

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0
  nvar = SIZE(mesh,1)


!---------------------------------------------------------------------------
! Inverse Fourier transform
!---------------------------------------------------------------------------
  DO m = 1,pmlib_ndim
    IF(ifft_seq(m) .EQ. 0)THEN
      GOTO 100
    END IF

!---------------------------------------------------------------------------
! Map topology to the fft direction
!---------------------------------------------------------------------------
    IF(m .EQ. 1)THEN
      topo_send = topo_in
    END IF

    IF(ifft_seq(m) .EQ. 1)THEN
      topo_recieve = topo_all%xpencil
    ELSEIF(ifft_seq(m) .EQ. 2)THEN
      topo_recieve = topo_all%ypencil
    ELSE
        ierr = -1
        CALL pmlib_write(caller, 'ifft direction unknown.')
        GOTO 9999
    END IF

    CALL pmlib_mesh_map(topo_send,topo_recieve,2*nvar,ierr)
    CALL pmlib_comm_pack(mesh_fft,ierr)
    CALL pmlib_comm_unpack(topo_recieve,mesh_fft,ierr)
    CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Do IFFTs
!---------------------------------------------------------------------------
    IF(ifft_seq(m) .EQ. 1)THEN ! IFFT x-pencils

      dx    = topo_recieve%dx
      ncell = topo_recieve%ncell
      nfft  = ncell(1)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(ifft_in(nfft), ifft_out(nfft))

        DO j = 1, ncell(2)
          DO l = 1,nvar

! Store fft pencil
            IF(PRESENT(fft_shift) .AND. fft_shift)THEN
              DO i = 1, nfft/2
                ifft_in(i) = mesh_fft(l,i + nfft/2,j)
              END DO
              DO i = nfft/2 + 1, nfft
                ifft_in(i) = mesh_fft(l,i - nfft/2,j)
              END DO
            ELSE
              DO i = 1, nfft
                ifft_in(i) = mesh_fft(l,i,j)
              END DO
            END IF
! Inverse Fourier transform
            CALL ifft( ifft_in, ifft_out, nfft )
! Store kernel
            DO i = 1, ncell(1)
              mesh_fft(l,i,j) = ifft_out(i)/REAL(nfft,MK)
            END DO

         END DO !l
        END DO !j

    ELSEIF(ifft_seq(m) .EQ. 2)THEN ! IFFT y-pencils

      dx     = topo_recieve%dx
      ncell  = topo_recieve%ncell
      nfft = ncell(2)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(ifft_in(nfft), ifft_out(nfft))

        DO i = 1, ncell(1)
          DO l = 1,nvar

! Store fft pencil
            IF(PRESENT(fft_shift) .AND. fft_shift)THEN
              DO j = 1, nfft/2
                ifft_in(j) = mesh_fft(l,i,j + nfft/2)
              END DO
              DO j = nfft/2 + 1, nfft
                ifft_in(j) = mesh_fft(l,i,j - nfft/2)
              END DO
            ELSE
              DO j = 1, nfft
                ifft_in(j) = mesh_fft(l,i,j)
              END DO
            END IF
! Inverse Fourier transform
            CALL ifft( ifft_in, ifft_out, nfft )
! Store kernel
            DO j = 1, ncell(2)
              mesh_fft(l,i,j) = ifft_out(j)/REAL(nfft,MK)
            END DO

          END DO !l
        END DO !i

    END IF ! fft direction

    DEALLOCATE(ifft_in, ifft_out)

!---------------------------------------------------------------------------
! Shift topology reciever to sender
!---------------------------------------------------------------------------
    topo_send = topo_recieve

  END DO ! fft_seq
 100 CONTINUE

!---------------------------------------------------------------------------
! Map to the output topology
!---------------------------------------------------------------------------
  CALL pmlib_mesh_map(topo_send,topo_out,2*nvar,ierr)
  CALL pmlib_comm_pack(mesh_fft,ierr)
  CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
  CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Map boundaries
!---------------------------------------------------------------------------
  DO i = 1,pmlib_ndim
    CALL pmlib_mesh_map_ghost(topo_out,i,2*nvar,ierr)
    CALL pmlib_comm_pack(mesh_fft,ierr)
    CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
    CALL pmlib_comm_finalise(ierr)
  END DO

!---------------------------------------------------------------------------
! Allocate the real mesh and extract the real part of the complex mesh
!---------------------------------------------------------------------------
  ncell  = topo_out%ncell
  nghost = topo_out%nghost

  IF( ASSOCIATED(mesh) ) THEN
    DEALLOCATE(mesh,stat=ierr)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF

  ALLOCATE(mesh(nvar, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)
  IF (ierr .NE. 0) THEN
    CALL pmlib_write(caller,'Failed to allocate array.')
    GOTO 9999
  ENDIF

! Extract the real part
    DO j = 1 - nghost(3), ncell(2) + nghost(4)
      DO i = 1 - nghost(1), ncell(1) + nghost(2)
        DO l = 1,nvar
          mesh(l,i,j) = REAL(mesh_fft(l,i,j))
        END DO
      END DO
    END DO

!---------------------------------------------------------------------------
! Deallocate the Fourier coefficients
!---------------------------------------------------------------------------
  DEALLOCATE(mesh_fft)

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_ifft





!---------------------------------------------------------------------------
! Inverse fast Fourier transform
! This subroutine is based on the implementation of the Glassman general
! N fft given by:
! W. E. Ferguson: 
! "A simple derivation of Glassman's general N fast  Fourier transform", 
!  Comp. & Math. With Appls. 1982
!---------------------------------------------------------------------------
SUBROUTINE ifft(fft_in,fft_out,nfft)

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  COMPLEX(MKC),DIMENSION(:),POINTER,INTENT(IN)  :: fft_in
  INTEGER,INTENT(IN)                            :: nfft
  COMPLEX(MKC),DIMENSION(:),POINTER,INTENT(OUT) :: fft_out

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  REAL(MK)                               :: PI
  INTEGER                                :: i, a, b, c
  LOGICAL                                :: inu

  COMPLEX(MKC)                           :: delta, omega, sumation 
  REAL(MK)                               :: angle
  INTEGER                                :: ia, ib, ic, jc, jrc

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  PI = ACOS(-1.0_MK)

  IF( ASSOCIATED(fft_out) )THEN
    IF( SIZE(fft_out,1) .NE. nfft )THEN
      DEALLOCATE( fft_out )
      ALLOCATE( fft_out(nfft) ) 
    END IF
  ELSE
    ALLOCATE( fft_out(nfft) ) 
  END IF

  IF( ASSOCIATED(fft_tmp) )THEN
    IF( SIZE(fft_tmp,1) .NE. nfft )THEN
      DEALLOCATE( fft_tmp )
      ALLOCATE( fft_tmp(nfft) ) 
    END IF
  ELSE
    ALLOCATE( fft_tmp(nfft) ) 
  END IF

  DO i = 1,nfft
    IF( i .LE. SIZE(fft_in) )THEN
      fft_out(i) = fft_in(i)
    ELSE
      fft_out(i) = CMPLX(0.0_MK,0.0_MK,MKC)
    END IF
  END DO

  a = 1
  b = nfft
  c = 1
  inu = .TRUE.

 10 CONTINUE

  IF (b .GT. 1)THEN
    GO TO 30
  END IF

  IF(inu)THEN
    GO TO 9999
  END IF

  DO i = 1,nfft
    fft_out(i) = fft_tmp(i)
  END DO

  GO TO 9999

 30 CONTINUE
  
  a = c*a
  DO c = 2,b
    IF(MOD(b,c) .EQ. 0)THEN
      GO TO 50
    END IF
  END DO

 50 CONTINUE

  b = b/c

  angle = 2.0_MK*PI/REAL(a*c,MK)

  delta = CMPLX(COS(ANGLE),SIN(ANGLE),MKC)

  omega = CMPLX(1.0_MK, 0.0_MK,MKC)

  IF(inu)THEN

    DO ic = 1,c
      DO ia = 1,a
        DO ib = 1,b
          sumation = fft_out(ib + b*(c - 1) + b*c*(ia - 1) )
          DO jrc = 2,c
            jc = c + 1 - jrc
            sumation = fft_out(ib + b*(jc - 1) + b*c*(ia - 1) ) + omega * sumation
          END DO
          fft_tmp(ib + b*(ia - 1) + b*a*(ic - 1) ) = sumation
        END DO
        omega = delta *omega
      END DO
    END DO

  ELSE

    DO ic = 1,c
      DO ia = 1,a
        DO ib = 1,b
          sumation = fft_tmp(ib + b*(c - 1) + b*c*(ia - 1) )
          DO jrc = 2,c
            jc = c+1-jrc
            sumation = fft_tmp(ib + b*(jc - 1) + b*c*(ia - 1) ) + omega * sumation
          END DO
          fft_out(ib + b*(ia - 1) + b*a*(ic - 1) ) = sumation
        END DO
        omega = delta *omega
      END DO
    END DO
  END IF

  inu = .NOT.inu

  GO TO 10

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
9999 CONTINUE

RETURN
END SUBROUTINE ifft

!---------------------------------------------------------------------------
! pmlib_mesh_allocate.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_mesh_allocate(topo,mesh,ierr)

USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology)                      :: topo
  TYPE(class_mesh)                          :: mesh
  INTEGER, INTENT(OUT)                      :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  INTEGER,DIMENSION(pmlib_ndim)             :: ncell
  INTEGER,DIMENSION(2*pmlib_ndim)           :: nghost

!---------------------------------------------------------------------------
! Allocate the multi level, multi patch type (not the actual mesh)
!---------------------------------------------------------------------------
  IF( ASSOCIATED(mesh%vort) ) DEALLOCATE( mesh%vort, stat=ierr)
  IF( ASSOCIATED(mesh%vel) ) DEALLOCATE( mesh%vel, stat=ierr)
  IF( ASSOCIATED(mesh%dvort)) DEALLOCATE( mesh%dvort, stat=ierr)

  IF (ierr .NE. 0) THEN
    CALL pmlib_write('pmlib_allocate_mesh','Failed to deallocate array.')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! Allocate the mesh
!---------------------------------------------------------------------------
  ncell  = topo%ncell
  nghost = topo%nghost

  ALLOCATE( mesh%vel(pmlib_ndim, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)

  ALLOCATE( mesh%vort(pmlib_nvort, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)

  ALLOCATE( mesh%dvort(pmlib_nvort, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)

  IF (ierr .NE. 0) THEN
    CALL pmlib_write('pmlib_allocate_mesh','Failed to allocate array.')
    GOTO 9999
  ENDIF


!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_mesh_allocate

!---------------------------------------------------------------------------
! pmlib_communication.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_communication

USE pmlib_mod_parameters
USE pmlib_mod_write 

IMPLICIT NONE

  TYPE class_comm_buffer
    INTEGER                                 :: nsend, nrecieve
    INTEGER,DIMENSION(pmlib_ndim)           :: ncell_send, ncell_recieve
    INTEGER                                 :: npart_send, npart_recieve

    REAL(MK),DIMENSION(:,:,:),POINTER       :: mesh_send    => NULL()
    REAL(MK),DIMENSION(:,:,:),POINTER       :: mesh_recieve => NULL()

    REAL(MK),DIMENSION(:,:),POINTER         :: part_send    => NULL()
    REAL(MK),DIMENSION(:,:),POINTER         :: part_recieve => NULL()
  END TYPE class_comm_buffer

  TYPE class_communication
    INTEGER                                 :: ncomm
    INTEGER                                 :: npacked
! type of communication
! 1: hole mesh (mapping of ghost points are not ensured)
! 2: superposition of mesh boundaries
! 3: replacing the values of the ghost cells
! 4: moving particles
    INTEGER                                 :: ctype
    INTEGER,DIMENSION(:),POINTER            :: proc_send,proc_recieve
    INTEGER,DIMENSION(:,:),POINTER          :: imin_send, imax_send
    INTEGER,DIMENSION(:,:),POINTER          :: imin_recieve, imax_recieve
    INTEGER,DIMENSION(:,:),POINTER          :: ncell_send, ncell_recieve
    INTEGER,DIMENSION(:),POINTER            :: npart_send, npart_recieve
    INTEGER,DIMENSION(:),POINTER            :: ipart0, ipart1, ipart2
    INTEGER,DIMENSION(:),POINTER            :: comm_dir
    INTEGER                                 :: ncommseq
    INTEGER,DIMENSION(:,:,:),POINTER        :: icommseq
  END TYPE class_communication

  TYPE(class_communication)                    :: communication

  TYPE(class_comm_buffer),DIMENSION(:),POINTER :: comm_buffer => NULL()

  INTERFACE pmlib_comm_pack
    MODULE PROCEDURE pmlib_comm_pack_mesh_real
    MODULE PROCEDURE pmlib_comm_pack_mesh_complex
    MODULE PROCEDURE pmlib_comm_pack_part
  END INTERFACE

  INTERFACE pmlib_comm_unpack
    MODULE PROCEDURE pmlib_comm_unpack_mesh_real
    MODULE PROCEDURE pmlib_comm_unpack_mesh_complex
    MODULE PROCEDURE pmlib_comm_unpack_part
    MODULE PROCEDURE pmlib_comm_unpack_part_pos_check
  END INTERFACE

CONTAINS

#include "communication/pmlib_comm_pack.f"

#include "communication/pmlib_comm_unpack.f"

#include "communication/pmlib_comm_finalise.f"


END MODULE pmlib_mod_communication

!---------------------------------------------------------------------------
! pmlib_fourier_fft_fftw.f
!   version: 2D single-core
!---------------------------------------------------------------------------
! <<HEADER>>
!---------------------------------------------------------------------------
SUBROUTINE pmlib_fft( topo_all,topo_in,mesh,topo_out,mesh_fft,fft_seq, & 
                    & ierr,fft_shift)

IMPLICIT NONE

INCLUDE 'fftw3.f'
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_topology_all)                        :: topo_all
  TYPE(class_topology)                            :: topo_in
  TYPE(class_topology)                            :: topo_out
  REAL(MK),DIMENSION(:,:,:),POINTER               :: mesh
  INTEGER, DIMENSION(pmlib_ndim), INTENT(IN)      :: fft_seq
  LOGICAL, OPTIONAL, INTENT(IN)                   :: fft_shift
  COMPLEX(MKC),DIMENSION(:,:,:),POINTER           :: mesh_fft
  INTEGER, INTENT(OUT)                            :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=10)                 :: caller = 'pmlib_fft'
  INTEGER                           :: i,j,k,l,m

  INTEGER, DIMENSION(pmlib_ndim)    :: ncell
  INTEGER, DIMENSION(2*pmlib_ndim)  :: nghost
  REAL(MK), DIMENSION(pmlib_ndim)   :: xmin, xmax, dx 

  INTEGER                           :: nvar
  INTEGER                           :: nfft

  COMPLEX(MKC),DIMENSION(:),POINTER :: fft_in  => NULL()
  COMPLEX(MKC),DIMENSION(:),POINTER :: fft_out => NULL()

  INTEGER                           :: fft_plan

  TYPE(class_topology)              :: topo_send
  TYPE(class_topology)              :: topo_recieve

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0
  nvar = SIZE(mesh,1)

!---------------------------------------------------------------------------
! Move the real mesh to the complex fft mesh
!---------------------------------------------------------------------------
  ncell  = topo_in%ncell
  nghost = topo_in%nghost

  IF( ASSOCIATED(mesh_fft) ) THEN
    DEALLOCATE(mesh_fft,stat=ierr)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF

  ALLOCATE(mesh_fft(nvar, &
          & 1-nghost(1):ncell(1)+nghost(2), &
          & 1-nghost(3):ncell(2)+nghost(4)), &
          & stat=ierr)
  IF (ierr .NE. 0) THEN
    CALL pmlib_write(caller,'Failed to allocate array.')
    GOTO 9999
  ENDIF

    DO j = 1 - nghost(3), ncell(2) + nghost(4)
      DO i = 1 - nghost(1), ncell(1) + nghost(2)
        DO l = 1,nvar
          mesh_fft(l,i,j) = CMPLX(mesh(l,i,j),0.0_MK,MKC)
        END DO
      END DO
    END DO

!---------------------------------------------------------------------------
! Fourier transform
!---------------------------------------------------------------------------
  DO m = 1,pmlib_ndim
    IF(fft_seq(m) .EQ. 0)THEN
      GOTO 100
    END IF
!---------------------------------------------------------------------------
! Map topology to the fft direction
!---------------------------------------------------------------------------
    IF(m .EQ. 1)THEN
      topo_send = topo_in
    END IF

    IF(fft_seq(m) .EQ. 1)THEN
      topo_recieve = topo_all%xpencil
    ELSEIF(fft_seq(m) .EQ. 2)THEN
      topo_recieve = topo_all%ypencil
    ELSE
        ierr = -1
        CALL pmlib_write(caller, 'fft direction unknown.')
        GOTO 9999
    END IF

    CALL pmlib_mesh_map(topo_send,topo_recieve,2*nvar,ierr)
    CALL pmlib_comm_pack(mesh_fft,ierr)
    CALL pmlib_comm_unpack(topo_recieve,mesh_fft,ierr)
    CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Do FFTs
!---------------------------------------------------------------------------
    IF(fft_seq(m) .EQ. 1)THEN ! FFT x-pencils

      ncell = topo_recieve%ncell
      nfft  = ncell(1)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(fft_in(nfft), fft_out(nfft))

! Setup fftw plan
      CALL dfftw_plan_dft_1d( fft_plan, nfft, fft_in, fft_out, & 
                            & FFTW_FORWARD, FFTW_ESTIMATE)

      DO j = 1, ncell(2)
        DO l = 1,nvar

! Store fft pencil
          IF(PRESENT(fft_shift) .AND. fft_shift)THEN
            DO i = 1, nfft/2
              fft_in(i) = mesh_fft(l,i + nfft/2,j)
            END DO
            DO i = nfft/2 + 1, nfft
              fft_in(i) = mesh_fft(l,i - nfft/2,j)
            END DO
          ELSE
            DO i = 1, nfft
              fft_in(i) = mesh_fft(l,i,j)
            END DO
          END IF
! Fourier transform
          CALL dfftw_execute_dft( fft_plan, fft_in, fft_out )

! Store mesh
          DO i = 1, ncell(1)
            mesh_fft(l,i,j) = fft_out(i)
          END DO

       END DO !l
      END DO !j

! Destroy fftw plan
      CALL dfftw_destroy_plan( fft_plan )
      CALL dfftw_cleanup()

    ELSEIF(fft_seq(m) .EQ. 2)THEN ! FFT y-pencils

      ncell = topo_recieve%ncell
      nfft  = ncell(2)
      IF(MOD(nfft,2) .NE. 0)THEN
        ierr = -1
        CALL pmlib_write(caller, 'nfft is an odd number.')
        GOTO 9999
      END IF

      ALLOCATE(fft_in(nfft), fft_out(nfft))

! Setup fftw plan
      CALL dfftw_plan_dft_1d( fft_plan, nfft, fft_in, fft_out, & 
                            & FFTW_FORWARD, FFTW_ESTIMATE)

      DO i = 1, ncell(1)
        DO l = 1,nvar

! Store fft pencil
          IF(PRESENT(fft_shift) .AND. fft_shift)THEN
            DO j = 1, nfft/2
              fft_in(j) = mesh_fft(l,i,j + nfft/2)
            END DO
            DO j = nfft/2 + 1, nfft
              fft_in(j) = mesh_fft(l,i,j - nfft/2)
            END DO
          ELSE
            DO j = 1, nfft
              fft_in(j) = mesh_fft(l,i,j)
            END DO
          END IF
! Fourier transform
          CALL dfftw_execute_dft( fft_plan, fft_in, fft_out )

! Store mesh
          DO j = 1, ncell(2)
            mesh_fft(l,i,j) = fft_out(j)
          END DO

        END DO !l
      END DO !i

! Destroy fftw plan
      CALL dfftw_destroy_plan( fft_plan )
      CALL dfftw_cleanup()

    END IF ! fft direction

    DEALLOCATE(fft_in, fft_out)

!---------------------------------------------------------------------------
! Shift topology reciever to sender
!---------------------------------------------------------------------------
    topo_send = topo_recieve

  END DO ! fft_seq
 100 CONTINUE

!---------------------------------------------------------------------------
! Map to the output topology
!---------------------------------------------------------------------------
  CALL pmlib_mesh_map(topo_send,topo_out,2*nvar,ierr)
  CALL pmlib_comm_pack(mesh_fft,ierr)
  CALL pmlib_comm_unpack(topo_out,mesh_fft,ierr)
  CALL pmlib_comm_finalise(ierr)

!---------------------------------------------------------------------------
! Deallocate local pointers
!---------------------------------------------------------------------------

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_fft

!---------------------------------------------------------------------------
! pmlib_patch.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
MODULE pmlib_mod_patch

USE pmlib_mod_parameters
USE pmlib_mod_write

IMPLICIT NONE

!---------------------------------------------------------------------------
! Define patch class
!---------------------------------------------------------------------------
  TYPE class_patch
    INTEGER                          :: ptype      !patch type
    INTEGER                          :: level      !resolution level
    INTEGER, DIMENSION(2)            :: parent     !patch parent
    REAL(MK),DIMENSION(pmlib_ndim)   :: xmin       !minimum physical extent
    REAL(MK),DIMENSION(pmlib_ndim)   :: xmax       !maximum physical extent
    INTEGER, DIMENSION(pmlib_ndim)   :: ncell      !number of mesh cells
    REAL(MK),DIMENSION(pmlib_ndim)   :: dx         !resolution
    INTEGER, DIMENSION(pmlib_ndim)   :: bound_cond !boundary conditions
    INTEGER                          :: nghost     !number of ghost points
    INTEGER, DIMENSION(pmlib_ndim)   :: fft_seq    !sequence in which to do ffts
  END TYPE class_patch

!----------------------------------------------------------------------------
! Interfaces
!----------------------------------------------------------------------------
  INTERFACE pmlib_patch_adjust
    MODULE PROCEDURE pmlib_patch_adjust
  END INTERFACE

CONTAINS

#include "patch/pmlib_patch_adjust.f"


END MODULE pmlib_mod_patch

!---------------------------------------------------------------------------
! pmlib_parameters_check.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_parameters_check(ierr)

IMPLICIT NONE
!-------------------------------------------------------------------------
! Arguments
!-------------------------------------------------------------------------
  INTEGER, INTENT(OUT) :: ierr

!-------------------------------------------------------------------------
! Local variables
!-------------------------------------------------------------------------
  CHARACTER(LEN=22)                 :: caller = 'pmlib_parameters_check'

!---------------------------------------------------------------------------
! Numerical parameters
!---------------------------------------------------------------------------
  IF( pmlib_poisson_kernel .NE. 1 .AND. & 
    & pmlib_poisson_kernel .NE. 2 )THEN
    ierr = -1
    CALL pmlib_write(caller, & 
        & 'pmlib_poisson_kernel is incorrectly set.')
    GO TO 9999
  END IF

  IF( pmlib_poisson_order .NE. 0 .AND. &
    & pmlib_poisson_order .NE. 2 .AND. &
    & pmlib_poisson_order .NE. 4 .AND. &
    & pmlib_poisson_order .NE. 6 .AND. &
    & pmlib_poisson_order .NE. 8 .AND. &
    & pmlib_poisson_order .NE. 10 )THEN
    ierr = -1
    CALL pmlib_write(caller, &
        & 'pmlib_poisson_order is incorrectly set.')
    GO TO 9999
  END IF

  IF( pmlib_poisson_order .GT. 0 .AND. &
    & pmlib_regularisation_radius .LT. 1.0_MK )THEN
    ierr = -1
    CALL pmlib_write(caller, &
        & 'pmlib_regularisation_radius is incorrectly set.')
    GO TO 9999
  END IF

  IF( pmlib_fd_order .NE. 2 .AND. &
    & pmlib_fd_order .NE. 4 )THEN
    ierr = -1
    CALL pmlib_write(caller, &
        & 'pmlib_fd_order is incorrectly set.')
    GO TO 9999
  END IF

  IF( pmlib_interpolation_order .NE. 3 .AND. &
    & pmlib_interpolation_order .NE. 4 )THEN
    ierr = -1
    CALL pmlib_write(caller, &
        & 'pmlib_interpolation_order is incorrectly set.')
    GO TO 9999
  END IF

  IF( pmlib_time_integration_order .NE. 1 .AND. &
    & pmlib_time_integration_order .NE. 2 .AND. &
    & pmlib_time_integration_order .NE. 3 )THEN
    ierr = -1
    CALL pmlib_write(caller, &
        & 'pmlib_interpolation_order is incorrectly set.')
    GO TO 9999
  END IF

!----------------------------------------------------------------------------
! Return
!----------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_parameters_check

!---------------------------------------------------------------------------
! pmlib_comm_finalise.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_comm_finalise(ierr)

IMPLICIT NONE

!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  INTEGER, INTENT(OUT)                        :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=20)        :: caller = 'pmlib_comm_finalise'
  INTEGER                                     :: i

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! Deallocate buffer
!---------------------------------------------------------------------------
  IF( ASSOCIATED(comm_buffer) ) THEN
    DO i = 1,communication%ncomm
      IF( ASSOCIATED(comm_buffer(i)%mesh_send) ) THEN
        DEALLOCATE(comm_buffer(i)%mesh_send)
      END IF  
      IF( ASSOCIATED(comm_buffer(i)%mesh_recieve) ) THEN
        DEALLOCATE(comm_buffer(i)%mesh_recieve)
      END IF  
      IF( ASSOCIATED(comm_buffer(i)%part_send) ) THEN
        DEALLOCATE(comm_buffer(i)%part_send)
      END IF  
      IF( ASSOCIATED(comm_buffer(i)%part_recieve) ) THEN
        DEALLOCATE(comm_buffer(i)%part_recieve)
      END IF  
    END DO

    DEALLOCATE(comm_buffer)
  END IF  

!---------------------------------------------------------------------------
! Deallocate communication parameters
!---------------------------------------------------------------------------
  IF( ASSOCIATED(communication%proc_send) ) THEN
    DEALLOCATE(communication%proc_send)
  END IF  
  IF( ASSOCIATED(communication%proc_recieve) ) THEN
    DEALLOCATE(communication%proc_recieve)
  END IF 

  IF( ASSOCIATED(communication%imin_send) ) THEN
    DEALLOCATE(communication%imin_send)
  END IF 

  IF( ASSOCIATED(communication%imax_send) ) THEN
    DEALLOCATE(communication%imax_send)
  END IF 

  IF( ASSOCIATED(communication%imin_recieve) ) THEN
    DEALLOCATE(communication%imin_recieve)
  END IF 

  IF( ASSOCIATED(communication%imax_recieve) ) THEN
    DEALLOCATE(communication%imax_recieve)
  END IF 

  IF( ASSOCIATED(communication%ncell_send) ) THEN
    DEALLOCATE(communication%ncell_send)
  END IF

  IF( ASSOCIATED(communication%ncell_recieve) ) THEN
    DEALLOCATE(communication%ncell_recieve)
  END IF

  IF( ASSOCIATED(communication%npart_send) ) THEN
    DEALLOCATE(communication%npart_send)
  END IF

  IF( ASSOCIATED(communication%npart_recieve) ) THEN
    DEALLOCATE(communication%npart_recieve)
  END IF

  IF( ASSOCIATED(communication%ipart0) ) THEN
    DEALLOCATE(communication%ipart0)
  END IF

  IF( ASSOCIATED(communication%ipart1) ) THEN
    DEALLOCATE(communication%ipart1)
  END IF

  IF( ASSOCIATED(communication%ipart2) ) THEN
    DEALLOCATE(communication%ipart2)
  END IF

  IF( ASSOCIATED(communication%comm_dir) ) THEN
    DEALLOCATE(communication%comm_dir)
  END IF

  IF( ASSOCIATED(communication%icommseq) ) THEN
    DEALLOCATE(communication%icommseq)
  END IF

  communication%npacked  = 0
  communication%ncomm    = 0
  communication%ncommseq = 0

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN
END SUBROUTINE pmlib_comm_finalise

!------------------------------------------------------------------------------
! pmlib_particles_map.f
!   version: 2D single-core
!---------------------------------------------------------------------------
!                  __    __
!    ___  _ _     / /__ / /
!   | _ \/ ` \ _ / // // _ \
!   | ,_/_,_,_\  \_/\_/\___/
!   |_|                      Mads M. Hejlesen* and Jens H. Walther*^
!                            * Technical University of Denmark
!                            ^ ETH-Zurich
!
!---------------------------------------------------------------------------
! Copyright (c) 2014 Technical University of Denmark, 
!                    Department of Mechanical Engineering
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, see <http://www.gnu.org/licenses/>
!
! Contact: mmhej@mek.dtu.dk or jhwa@mek.dtu.dk
!---------------------------------------------------------------------------
SUBROUTINE pmlib_particles_map(patch,topo,part,dir,nvar_send,ierr)

USE pmlib_mod_communication
USE pmlib_mod_patch
USE pmlib_mod_topology

IMPLICIT NONE
!---------------------------------------------------------------------------
! Arguments
!---------------------------------------------------------------------------
  TYPE(class_patch)                         :: patch
  TYPE(class_topology)                      :: topo
  TYPE(class_particles)                     :: part
  INTEGER, INTENT(IN)                       :: dir !direction
  INTEGER, INTENT(IN)                       :: nvar_send
  INTEGER, INTENT(OUT)                      :: ierr

!---------------------------------------------------------------------------
! Local variables
!---------------------------------------------------------------------------
  CHARACTER(LEN=19)                     :: caller = 'pmlib_particles_map'
  INTEGER                               :: ncomm, icomm
  INTEGER                               :: iproc, jproc
  INTEGER                               :: i,j,k

  INTEGER, DIMENSION(0:2)               :: npart_dir

  INTEGER                               :: ineigh, neigh
  INTEGER                               :: ipart0, ipart1, ipart2
  REAL(MK), DIMENSION(pmlib_ndim)       :: xmin, xmax
  REAL(MK), DIMENSION(pmlib_ndim)       :: dx

  INTEGER                               :: npart_send, npart_recieve
  INTEGER                               :: npart_remove

!---------------------------------------------------------------------------
! Initiate subroutine
!---------------------------------------------------------------------------
  ierr = 0

!---------------------------------------------------------------------------
! Find number of particles to communicate
!   index 0 is not moved
!   index 1 is moved in the negative direction 
!   index 2 is moved in the possitive direction
!---------------------------------------------------------------------------
  xmin = topo%xmin
  xmax = topo%xmax 
  npart_dir  = 0
  npart_remove = 0

  DO i = 1,topo%npart
    
    IF( part%pos(dir,i) .LT. xmin(dir) )THEN

      IF( topo%bound_cond(2*dir-1) .NE. 0 )THEN
        npart_dir(1) = npart_dir(1) + 1
      ELSE
        npart_remove = npart_remove + 1
      END IF

    ELSEIF( part%pos(dir,i) .GE. xmax(dir) )THEN 

      IF( topo%bound_cond(2*dir) .NE. 0 )THEN
        npart_dir(2) = npart_dir(2) + 1
      ELSE
        npart_remove = npart_remove + 1
      END IF

    ELSE
      npart_dir(0) = npart_dir(0) + 1
    END IF

  END DO

!  IF(npart_dir(1) .NE. 0)THEN
!    CALL pmlib_write(mpi_rank,caller,'Communicate particles')
!  ELSEIF(npart_dir(2) .NE. 0)THEN
!    CALL pmlib_write(mpi_rank,caller,'Communicate particles')
!  END IF

!  IF(npart_remove .NE. 0)THEN
!    CALL pmlib_write(mpi_rank,caller,'Particles out of bounce! - removing')
!  END IF

!---------------------------------------------------------------------------
! Find indexes of particles to communicate
!---------------------------------------------------------------------------
  ALLOCATE( communication%ipart0(npart_dir(0)) )
  ALLOCATE( communication%ipart1(npart_dir(1)) )
  ALLOCATE( communication%ipart2(npart_dir(2)) )

  ipart0 = 0
  ipart1 = 0
  ipart2 = 0

  DO i = 1,topo%npart
    
    IF( part%pos(dir,i) .LT. xmin(dir) )THEN
      IF( topo%bound_cond(2*dir-1) .NE. 0 )THEN
        ipart1 = ipart1 + 1
        communication%ipart1(ipart1) = i
        IF( part%pos(dir,i) .LT. patch%xmin(dir) )THEN
          part%pos(dir,i) = part%pos(dir,i) &
                        & + ( patch%xmax(dir) - patch%xmin(dir) )
        END IF
      END IF

    ELSEIF( part%pos(dir,i) .GE. xmax(dir) )THEN
      IF( topo%bound_cond(2*dir) .NE. 0 )THEN
        ipart2 = ipart2 + 1
        communication%ipart2(ipart2) = i
        IF( part%pos(dir,i) .GE. patch%xmax(dir) )THEN
          part%pos(dir,i) = part%pos(dir,i) &
                        & - ( patch%xmax(dir) - patch%xmin(dir) )
        END IF
      END IF

    ELSE
      ipart0 = ipart0 + 1
      communication%ipart0(ipart0) = i
    END IF
  END DO

  IF( ipart0 .NE. npart_dir(0) .OR. &
    & ipart1 .NE. npart_dir(1) .OR. &
    & ipart2 .NE. npart_dir(2) )THEN
    ierr = -1
    CALL pmlib_write( caller, &
              & 'Number of communicated particles are not consistent' )
    GOTO 9999
  END IF

!---------------------------------------------------------------------------
! Find number of communications
!---------------------------------------------------------------------------
  icomm = 0
  DO i = 1,2
    ineigh = 2*dir - 2 + i
    neigh = topo%ineigh(ineigh)

    IF( npart_dir(i) .NE. 0 .AND. neigh .NE. -1)THEN
      icomm = icomm + 1
    END IF
  END DO !ineigh

! add self communication
  icomm = icomm + 1

!---------------------------------------------------------------------------
! Allocate communication lists
!---------------------------------------------------------------------------
  ncomm               = icomm
  communication%ncomm = ncomm
  communication%ctype = 4

  ALLOCATE( communication%npart_send(ncomm) )
  ALLOCATE( communication%npart_recieve(ncomm) )
 
  ALLOCATE( communication%comm_dir(ncomm) )

!---------------------------------------------------------------------------
! Loop through neighbours
!---------------------------------------------------------------------------
  icomm = 0
  DO i = 1,2
    ineigh = 2*dir - 2 + i

    neigh = topo%ineigh(ineigh)

    IF( npart_dir(i) .NE. 0 .AND. neigh .NE. -1 )THEN

!---------------------------------------------------------------------------
! Count communications
!---------------------------------------------------------------------------
      icomm = icomm + 1
      communication%comm_dir(icomm) = i

!---------------------------------------------------------------------------
! Store number of particles
!---------------------------------------------------------------------------
      communication%npart_send(icomm)    = npart_dir(i)
      communication%npart_recieve(icomm) = npart_dir(i)

    END IF ! send part
  END DO !ineigh

!---------------------------------------------------------------------------
! Do self communications
!---------------------------------------------------------------------------
  icomm = icomm + 1
  communication%comm_dir(icomm) = 0

! Store number of particles
  communication%npart_send(icomm)    = npart_dir(0)
  communication%npart_recieve(icomm) = npart_dir(0)

!---------------------------------------------------------------------------
! Check number of communications
!---------------------------------------------------------------------------
  IF(icomm .NE. ncomm)THEN
    ierr = -1
    CALL pmlib_write(caller,'Number of communications are inconsistent')
    GOTO 9999
  ENDIF

!---------------------------------------------------------------------------
! Allocate communication buffer
!---------------------------------------------------------------------------
  IF( ASSOCIATED(comm_buffer) ) THEN
    DEALLOCATE(comm_buffer)
    IF (ierr .NE. 0) THEN
      CALL pmlib_write(caller,'Failed to deallocate array.')
      GOTO 9999
    ENDIF
  END IF 
  ALLOCATE( comm_buffer(ncomm) )

  DO j = 1,ncomm

    npart_send = communication%npart_send(j)
 
! Allocate send array for communication j
    ALLOCATE( comm_buffer(j)%part_send(nvar_send,npart_send) )
    comm_buffer(j)%nsend = nvar_send*npart_send
    comm_buffer(j)%npart_send = npart_send

! Allocate send array for communication j
    ALLOCATE( comm_buffer(j)%part_recieve(nvar_send,npart_send) )
    comm_buffer(j)%nrecieve = nvar_send*npart_send
    comm_buffer(j)%npart_recieve = npart_send

  END DO

!---------------------------------------------------------------------------
! set counter for number of packed variables
!---------------------------------------------------------------------------
  communication%npacked = 0

!---------------------------------------------------------------------------
! Return
!---------------------------------------------------------------------------
 9999 CONTINUE
RETURN

END SUBROUTINE pmlib_particles_map

#!/usr/bin/env bash

OK="\033[0;32mok\033[0m"
FAIL="\033[0;31mfail!\033[0m"
WARN="\033[0;33mwarnings\033[0m"

echo $1 >> $2

cmd="$1 2>&1"

output=`eval $cmd`

if [ $? -eq 0 ]
then
    if [ -z "$output" ]
    then
	# all ok
	printf "$OK\n"
    else
	# warning
	printf "$WARN\n"
	echo "$output" >> $2
    fi
else
    # error
    printf "$FAIL\n"
    echo "$output" >> $2
    printf "\n\033[0;31m%s\033[0m (check %s for details)\n\n%s\n\n" "$3" "$2" "$output"
    exit 1
fi
